import random
from math import *
import sys

from slithy.library import *

from common import *
from ressource import *







def get_oeil_box(vision):
	return vision.inset(0.4)

def get_oeil_box2(vision):
	return get_oeil_box(vision).move_left(1.5)

#second page: les 5 sens
def SecondPage(
		zoom=(SCALAR,0,1.0,0.0),
		slide1=(SCALAR,0.0,3.0,0.0),
		slide2=(SCALAR,0.0,3.0,0.0),
		sound=(SCALAR,0.0,3.0,0.0),
		sense=(SCALAR,-1.0,5.0,-1.0)):
	canva= get_cams("start")
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	senseBox=canva.top(0.3).inset(0.2).move_down(1.2)
	s=senseBox.width()/5
	senseBox=Rect(senseBox[0],senseBox[1],senseBox[0]+s,senseBox[1]+s)
	oeil_inset=0.4
	cams["vision"]=senseBox.move_right(4).inset(0.15)
	
	set_camera(canva.interp(get_cams("vision"),zoom))
	box=titleBox(canva)
	color(coldic.font)
	middle=get_middle(box)
	text(middle.x,middle.y,"Perception multi-chelle", timefont, size=canva.height()*titleSize, justify=0.5)
	
	thickness(thicknessSize)
	refArray=["doigt","langue","nez","oreille","oeil"]
	for i in range(0,5):
		frame(senseBox.move_right(i))
		push()
		insetCoef=0.0
		tmpBox=senseBox.move_right(i).inset(insetCoef)
		if i==3:
			tmpBox=tmpBox.move_right(slide1*1.5).move_down(slide1*1.5)
			tmpBox=tmpBox.move_left(slide2*0.8)
		if i==4:
			tmpBox=tmpBox.interp(get_oeil_box(get_cams("vision")),zoom)
		box_image(tmpBox,ims[refArray[i]])
		pop()
	
	thickness(thicknessSize*2)
	if sense>-1:
		alpha=1
		i=sense
		coef=0
		if sense<0:
			alpha=1+sense
			i=0
		elif sense<3:
			coef=(1.5-abs(sense-1.5))/1.5
		redbox=senseBox.move_right(i)
		redbox=scale_rect(redbox,1+coef,1.0)
		color(red,alpha)
		frame(redbox)
	
	if sound>epsilon:
		color(coldic.font,clamp(sound-0))
		tmpBox=senseBox.move_down(1.5).move_left(0.5)
		box_image(tmpBox, ims["son"], clamp(sound-0))
		tmpBox=tmpBox.move_right(0.5).move_up(0.3)
		p=get_middle(tmpBox)
		text(p.x,p.y,"- Ville",timefont,size=fontSize, anchor='tw')
		color(coldic.font,clamp(sound-1))
		text(p.x,p.y-fontSize*1.1,"- Voiture A, portire", timefont, size=fontSize, anchor='tw')
		color(coldic.font,clamp(sound-2))
		text(p.x,p.y-fontSize*2.2,"- Discussion 1", timefont, size=fontSize, anchor='tw')
	










def ThirdPage(
		alphaTitre=(SCALAR,0,1.0,0.0),
		deloin=(SCALAR,0,1.0,0.0),
		info=(SCALAR,0,1.0,0.0)):
	canva = get_cams("vision")
	set_camera(canva)
	cams_oeil_box=get_oeil_box(canva)
	cams_oeil_box2=get_oeil_box2(canva)
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	
	eye_box= cams_oeil_box.interp(cams_oeil_box2,deloin)
	box_image(eye_box,ims["oeil"],1.0-info*0.7)
	sapin_box= cams_oeil_box.move_right(1.2)
	
	color(coldic.font,alphaTitre*(1-clamp(info-3)))
	box=titleBox(canva)
	middle=get_middle(box)
	text(middle.x,middle.y,"Monde rel et monde virtuel", timefont, size=canva.height()*titleSize, justify=0.5)
	
	middle=get_middle(eye_box.bottom(0.3).move_down(1.0))
	
	alphac=deloin*deloin*deloin
#	color(coldic.font,alphaTitre*(1-deloin*2))
	box_image(sapin_box,ims["sapin2"],alphaTitre*(1-alphac))
	
#	color(coldic.font,alphaTitre*deloin*2-1)
	box_image(sapin_box,ims["sapin1"],alphaTitre*alphac)
	
	if info==0.0:
		return
	
	screen_box_init=eye_box.move_left(0.20).inset(0.15)
	screen_box=screen_box_init.interp(eye_box,clamp(info-1))
	createur_box=screen_box.move_right(0.5).move_down(0.5)
	box_image(screen_box,ims["ecran"],clamp(info))
	
	box_image(createur_box,ims["createur"],clamp(info-2))
	
	size=sapin_box.width()*0.5
	begin=get_middle(createur_box)
	begin.x=begin.x+createur_box.width()*0.5
	begin.y=begin.y+createur_box.height()*0.5
	end=get_middle(sapin_box)
	bulle=clamp(info-3)
	tmpc=0.35
	thickness(thicknessSize)
	if bulle>0.0:
		color(coldic.font,clamp(bulle/0.33))
		circle(size/6.0,begin.x,begin.y)
	if bulle>0.33:
		color(coldic.font,clamp((bulle-0.33)/0.33))
		circle(size/3.0,begin.x*(1-tmpc)+end.x*tmpc,begin.y*(1-tmpc)+end.y*tmpc)
	if bulle>0.66:
		color(coldic.font,clamp((bulle-0.66)/0.33))
		circle(size,end.x,end.y)
	color(coldic.font,1.0)









class Aliasing_state:
	def __init__(self):
		self.sound0=False
		self.sound1=False
		self.sound2=False
aliasing_state=Aliasing_state()

def Aliasing(
		build=(SCALAR,0.0,1.0,0.0),
		alphaecran=(SCALAR,0.0,1.0,0.0),
		poly=(SCALAR,0.0,1.0,0.0),
		sur=(SCALAR,0.0,1.0,0.0),
		sous=(SCALAR,0.0,1.0,0.0),
		ok=(SCALAR,0.0,1.0,0.0),
		showarrow=(SCALAR,0.0,1.0,0.0),
		arrow=(SCALAR,0.0,1.0,0.5),
		setCam=(BOOLEAN,False),
		big=(SCALAR,0.0,1.0,0.05)):
	canva= get_cams("aliasing")
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	
	if setCam:
		cams["current"]=get_cams("aliasing")
	set_camera(get_cams("current"))
	
	
	
	ecran_box=canva.inset(0.2).move_down(0.2).restrict_aspect(1.0)
	
	imbox=ecran_box.move_right(0.01).move_down(0.01) .inset(0.48).outset(0.1+50*big).restrict_aspect(ims["torus"].aspect)
	box_image(imbox,ims["torus"],build)
#	c=big+0.02
#	color(green,poly)
#	p=get_middle(ecran_box)
#	polygon(p.x-ecran_box.width()*0.4*c,p.y-ecran_box.height()*0.1*c,
#		p.x+ecran_box.width()*0.4*c,p.y-ecran_box.height()*0.35*c,
#		p.x+ecran_box.width()*0.45*c,p.y+ecran_box.height()*0.45*c)
	
	color(white,1)
	rectangle(ecran_box.move_left(1))
	rectangle(ecran_box.move_right(1))
	rectangle(ecran_box.move_up(1))
	rectangle(ecran_box.move_down(1))
	rectangle(ecran_box.move_left(1).move_up(1))
	rectangle(ecran_box.move_right(1).move_down(1))
	rectangle(ecran_box.move_up(1).move_right(1))
	rectangle(ecran_box.move_down(1).move_left(1))
	
	tbox=titleBox(canva)
	p=get_middle(tbox)
	color(coldic.font,build)
	text(p.x,p.y,"Taille des primitives graphiques",timefont,size=canva.height()*titleSize)

	
	color(black,clamp(build*2)*0.5)
	thickness(thicknessSize*0.7)
	Ecran(ecran_box,20,alphaecran)
	
	
	
	color(orange,clamp(build*2))
	thickness(thicknessSize*2)
	frame(ecran_box)
	thickness(thicknessSize)
	
	
	bar_box=canva.top(0.1).inset(0.1).move_down(2.5)
	res=PrecisionBar(bar_box,0.45,0.55,build)
	
	
	x=arrow*(bar_box[0]+bar_box.width()*0.2) + (1-arrow)*(bar_box[0]+bar_box.width()*0.8)
	
	color(black,showarrow)
	draw_arrow(x,bar_box[1]-2*fontSize,x,bar_box[1],thicknessSize*3, thicknessSize*6)
	
	if sur<epsilon and sous<epsilon and ok<epsilon:
		aliasing_state.__init__()
	
	fcoef=1.7
	if sur>epsilon:
		color(red,sur)
		p=get_middle(canva)
		text(p.x,p.y,"Objet inutilement dtaille",timefont,size=fontSize*fcoef, anchor='cc', justify=0.5)
	
	if sous>epsilon:
		color(red,sous)
		p=get_middle(canva)
		text(p.x,p.y,"Pas assez dtaille",timefont,size=fontSize*fcoef, anchor='cc', justify=0.5)
	
	if ok>epsilon:
		color(blue,ok)
		p=get_middle(canva)
		text(p.x,p.y,"Taille idale",timefont,size=fontSize*fcoef, anchor='cc')





def AntiAliasing(
		build=(SCALAR,0.0,3.0,0.0),
		setCam=(BOOLEAN,False),
		big=(SCALAR,0.0,1.0,0.3)):
	if setCam:
		cams["current"]=get_cams("antialiasing")
	set_camera(get_cams("current"))
	
	
	canva= get_cams("antialiasing")
	thicknessSize=canva.width()*0.005
	thickness(canva.width()*epsilon)
	fontSize=canva.height()*textSize
	tbox=titleBox(canva)
	p=get_middle(tbox)
	color(coldic.font,build)
	text(p.x,p.y,"Anti-aliasing",timefont,size=canva.height()*titleSize)
	
	methods_box=canva.top(0.2).inset(0.2).move_down(1.3)
	text(methods_box[0]-2*fontSize,methods_box[1]+methods_box.height()*0.5, "Mthodes classiques [Forrest85] bases sur", timefont, size=fontSize, anchor='w')

	color(coldic.font,clamp(build-1))
	methods_box=methods_box.move_down(1.3)
	text(methods_box[0]-2*fontSize,methods_box[1]+methods_box.height()*0.5,"- sur-chantillonnage [Barkans91]\n", timefont, size=fontSize, anchor='w')
	pixel_box=methods_box.right(0.2).restrict_aspect(1.0)
	thickness(wfunc(canva))
	pixel(pixel_box)
	text(pixel_box[0]+pixel_box.width()*0.5, pixel_box[1]+pixel_box.height()*1.2,"pixel", timefont, size=fontSize,anchor='cc')
	
	random.seed(29365745)
	for i in range(0,clamp(build-2)*40):
		x=pixel_box[0]+random.random()*pixel_box.width()
		y=pixel_box[1]+random.random()*pixel_box.height()
		color(random.random(),random.random(),random.random())
		dot(canva.width()*0.01,x,y)
	
	color(coldic.font,clamp(build-3))
	methods_box=methods_box.move_down(1.3)
	text(methods_box[0]-2*fontSize,methods_box[1]+methods_box.height()*0.5,"- sous-dcoupage [Haeberli90]", timefont,size=fontSize, anchor='w')
	pixel_box=methods_box.right(0.2).restrict_aspect(1.0)
	pixel(pixel_box)
	
	thickness(wfunc(canva))
	Ecran(pixel_box,8,clamp(build-4))
	
	color(coldic.font,clamp(build-5))
	bar_box=canva.bottom(0.1).inset(0.05).move_up(2.5)
	text(bar_box[0]+bar_box.width()*0.5, bar_box[1]+bar_box.height()*0.5,"Faible marge d'action (x10 maximum)", timefont,size=fontSize, anchor='cc')
	bar_box=bar_box.move_down(1)
	PrecisionBar(bar_box,0.45-clamp(build-6)*0.08,0.55,clamp(build-5))






def Complexification(
		build=(SCALAR,0.0,1.0,0.0),
		zoom=(SCALAR,0.0,1.0,0.0),
		bar=(SCALAR,0.0,1.0,0.0),
		hide=(SCALAR,0.0,1.0,1.0),
		setCam=(BOOLEAN,False),
		move=(SCALAR,-0.5,1.5,0.0),
		limitdown=(SCALAR,0.0,2.0,0.0),
		limitup=(SCALAR,0.0,2.0,0.0),
		comment=(SCALAR,0.0,2.0,0.0),
		slide=(SCALAR,0.0,1.0,0.0)
	):
	
	moveCoef=0.75
	canva2= get_cams("complexification")
	canva= get_cams("complexification").interp( get_cams("complexification").move_up(moveCoef), slide)

	if setCam:
		cams["current"]=get_cams("complexification")
	set_camera(get_cams("current"))

	thicknessSize=canva.width()*0.005
	thickness(thicknessSize)
	fontSize=canva.height()*textSize
	maxColor=purple
	color(coldic.font,build)
	tbox=titleBox(canva)
	p=get_middle(tbox)
	text(p.x,p.y,"Complexification",timefont,size=canva.height()*titleSize)

	color(coldic.font,build*hide)
	first_box=canva.top(0.2).inset(0.2).move_down(1.3)
	text(first_box[0]+first_box.width()*0.5, first_box[1]+first_box.height()*0.5,["Donne d'entre :\n prcision minimum + fonctions de complexification"], timefont, size=fontSize, justify=0.5,anchor="cc")


	bar_box=canva.bottom(0.1).inset(0.05)
	bar_box=bar_box.move_up(4)
	PrecisionBar(bar_box,0.45,0.55+bar*0.2,zoom*hide)
	color(coldic.font,zoom*hide)
	aabox=bar_box.left(0.1).move_right(4.5)
	frame(aabox)
	aabox=aabox.restrict_aspect(1.0)
	
	color(coldic.font,clamp(comment)*hide)
	text_plus_box=aabox.move_down(1.1).move_left(5).inset(0.2)
	text_plus_box=text_plus_box.move_up(3*clamp(slide-0.7)*5)
	res=text(text_plus_box[0], text_plus_box[1], "- Intervalle beaucoup moins limit", timefont, size=fontSize, anchor="cw", justify=0.0)

	color(coldic.font,clamp(comment-1)*hide)
	res=text(text_plus_box[0], text_plus_box[1]-fontSize*1.1, "- Complexification => modlisation procdurale", timefont, size=fontSize, anchor="cw", justify=0.0)
	canva2=canva.move_down(moveCoef)
	p=get_middle(titleBox(canva2))
	color(red.interp(black,slide),clamp(comment-1)*hide)
	
#	text(p.x,p.y,"Modlisation procdurale", timefont, size=canva.height()*titleSize*(0.7+0.3*slide))
	
	img_box=canva.top(0.2).left(0.2).restrict_aspect(1.0)
	img_box=img_box.move_down(1.6).move_right(0.7)
	small_box=aabox.move_up(2.0).restrict_aspect(1.0)
	small_box=small_box.move_left(2.5).move_right(2.5*move)
	img_box=img_box.interp(small_box,zoom)
	
	drawTrees(img_box,build*hide,False)
	
	limit_box=aabox.move_up(2.0)
	color(coldic.font,max(limitup,limitdown)*hide)
	frame(limit_box)
	color(green,max(limitup,limitdown)*hide)
	p=get_middle(limit_box)
	text(p.x,p.y, "?", timefont, size=limit_box.height()*0.8,anchor="cc")
	
	color(green,clamp(limitdown-1)*hide)
	text(limit_box[0]-limit_box.width()*0.4, limit_box[1]+limit_box.height()*0.5, "Utilisation des similarits,\ndescription fonctionnelle", timefont, size=fontSize,anchor="ce", justify=1.0)

	color(green,clamp(limitup-1)*hide)
	text(limit_box[0]+limit_box.width()*1.2, limit_box[1]+limit_box.height()*0.5, "Le crateur peut modliser\nune forme plus grossire", timefont, size=fontSize,anchor="cw", justify=0.0)
	
	
	p1=Vec2(small_box.move_right(2.5)[0]+small_box.width()*0.5, small_box[1]-small_box.height()*0.2)
	p2=Vec2(bar_box[0]+bar_box.width()*0.5, small_box[1]-small_box.height()*0.6)		
	if p1.x<p2.x:
		c=clamp(limitup-1)
		p1.x=p1.x*(1-c)+p2.x*c
	
	s=wfunc(canva)*2
	color(coldic.font,zoom*hide)
	
#	draw_arrow_2lines(p1,p2,s,s*3)




def Simplification(
		build=(SCALAR,0.0,1.0,0.0),
		smallTree=(SCALAR,0.0,1.0,0.0),
		textdebut=(SCALAR,0.0,4.0,0.0),
		precision=(SCALAR,0.0,1.0,0.0),
		bar=(SCALAR,0.0,1.0,0.0),
		cross=(SCALAR,0.0,1.0,0.0),
		limitesimp=(SCALAR,0.0,2.0,0.0),
		comment=(SCALAR,0.0,2.0,0.0),
		setCam=(BOOLEAN,False),
		move=(SCALAR,-0.5,1.5,0.0)):
	if setCam:
		cams["current"]=get_cams("simplification")
	set_camera(get_cams("current"))
	
	canva= get_cams("simplification")
	thicknessSize=canva.width()*0.005
	thickness(thicknessSize)
	fontSize=canva.height()*textSize
	maxColor=purple
	color(coldic.font,build)
	tbox=titleBox(canva)
	p=get_middle(tbox)
	text(p.x,p.y,"Simplification",timefont,size=canva.height()*titleSize)
	
	tttt1=["- donne d'entre :  prcision maximum\n- mthodes automatiques"]
	first_box=canva.top(0.2).inset(0.2).move_down(1.3)
	text(first_box[0]+first_box.width()*0.5, first_box[1]+first_box.height()*0.5, tttt1, timefont, size=fontSize, justify=0.0, anchor='cc')


	bar_box=canva.bottom(0.1).inset(0.05)
	bar_box=bar_box.move_up(4)
	PrecisionBar(bar_box,0.45-bar*0.2,0.55,clamp(precision))
	color(coldic.font,clamp(precision))
	aabox=bar_box.left(0.1).move_right(4.5)
	frame(aabox)
	
	color(coldic.font,clamp(comment))
	text_plus_box= aabox.move_down(1.1).move_left(3).inset(0.2).restrict_aspect(1.0)
	res=text(text_plus_box[0], text_plus_box[1], "- Intervalle d'observation plus grand", timefont, size=fontSize,anchor="cw")
	color(coldic.font,clamp(comment-1))
	text(text_plus_box[0], text_plus_box[1]-fontSize*1.1, "- Mais intrinsquement limit", timefont, size=fontSize,anchor="cw")

	img_box=canva.top(0.2).left(0.2).restrict_aspect(1.0)
	img_box=img_box.move_down(1.6).move_right(0.7)
	small_box=aabox.move_up(2.0)
	small_box=small_box.move_left(2*move)
	img_box=img_box.interp(small_box,smallTree)
	
	
	drawTrees(img_box,build,True)

	limit_box=aabox.move_up(2.0).restrict_aspect(1.0)
	color(coldic.font,cross)
	frame(limit_box)
	color(red,cross)
	p=get_middle(limit_box)
	text(p.x,p.y, "?", timefont, size=limit_box.height()*0.8,anchor="cc")
	limit_box=limit_box.move_right(1.2)
	color(coldic.font,pic(limitesimp,1,0.3))
	text(limit_box[0], limit_box[1]+limit_box.height()*0.5, "Simplification extrme\ndifficile", timefont, size=fontSize,anchor="cw")

	limit_box=limit_box.move_left(1.5)
	color(coldic.font,pic(limitesimp,2,0.3))
	text(limit_box[0]-fontSize, limit_box[1]+limit_box.height()*0.5, "Enrichissement\nlimit (mmoire)", timefont, justify=0.9, size=fontSize,anchor="ce")
	
	color(coldic.font,pic(textdebut,1,0.3))
	methods_box=first_box.move_down(2.7).move_left(0.2)
	text(methods_box[0], methods_box[1]+methods_box.height()*0.5, "Applique  de nombreuses reprsentations :", timefont, size=fontSize, justify=0,anchor="tw")
	text(methods_box[0]+fontSize*1.5, methods_box[1]+methods_box.height()*0.5-1.2*fontSize, "- Maillage [Rossignac93,Hoppe97,Luebke03]\n- Texture 2D, 3D [Williams83,Neyret98]\n- Surfels [Pfister00]\n- Imposteurs [Aliaga96]", timefont, size=fontSize, justify=0,anchor="tw")


	p1=Vec2(small_box[0]+small_box.width()*0.5, small_box[1]-small_box.height()*0.2)
	p2=Vec2(bar_box[0]+bar_box.width()*0.5, small_box[1]-small_box.height()*0.6)		
	s=wfunc(canva)*2
	color(coldic.font,clamp(precision))
	
#	draw_arrow_2lines(p1,p2,s,s*3)



def facto(box1,case,avan,w,fs,alpha):
	random.seed(246535)
	coef=0.5
	rayon1=box1.height()*0.3
	rayon2=box1.height()*0.5
	rayon3=box1.height()*0.7
	m=get_middle(box1)
	circleRayon=rayon1+(rayon2-rayon1)*clamp(avan)
	g1=0.8
	g2=0.6
	color(g1,g1,g1,alpha*clamp(avan))
	dot(circleRayon,m.x,m.y)
	color(g2,g2,g2,alpha)
	dot(rayon1,m.x,m.y)
	tmparray=["prairie","fort","ocan"]
	txt="C++\nOpenGL"
#	color(black,alpha*clamp(avan))
#	text(m.x,m.y+rayon1,"DG",timefont,size=fs*0.8,anchor='bc',justify=0.5)
	color(black,alpha)
	text(m.x,m.y,txt,timefont,size=fs*0.8,anchor='cc',justify=0.5)
	
	for i in range(1,int(case)):
		angle=random.random()*1.7-1
		d=Vec2(cos(angle),sin(angle))
		a=d*circleRayon
		coef=clamp(case-1-i)
		b=d*(circleRayon+(rayon3-circleRayon)*coef)
		Vec2.arrow(m+a,m+b,w)
		if i<len(tmparray)+1 and coef>0.9:
			pp=m+b*1.2
			if angle>0.8:
				text(pp.x,pp.y,tmparray[i-1], timefont,size=fs,anchor='ce')
			else:
				text(pp.x,pp.y,tmparray[i-1], timefont,size=fs,anchor='cw')

def EtatArt(
		build=(SCALAR,0.0,1.0,0.0),
		des=(SCALAR,0.0,1.0,0.0),
		showdes=(SCALAR,0.0,1.0,0.0),
		showTab=(SCALAR,0.0,1.0,0.0),
		x1=(SCALAR,0.0,1.0,0.0),
		x2=(SCALAR,0.0,1.0,0.0),
		cam=(SCALAR,0.0,6.0,0.0),
		fractale=(SCALAR,0.0,1.0,0.0),
		showArrow=(SCALAR,0.0,1.0,0.0),
		carac=(SCALAR,0.0,1.0,0.0),
		picture=(SCALAR,0.0,1.0,0.0),
		platonic=(SCALAR,0.0,1.0,0.0),
		multi=(SCALAR,0.0,1.0,0.0),
		tii=(SCALAR,0.0,1.0,0.0),
		processus0=(SCALAR,0.0,1.0,0.0),
		lsystem=(SCALAR,0.0,2.0,0.0),
		cpfg=(SCALAR,0.0,2.0,0.0),
		particulier=(SCALAR,0.0,1.0,0.0),
		particulier_t=(SCALAR,0.0,1.0,0.0),
		case=(SCALAR,0.0,20.0,1.999),
		dg=(SCALAR,0.0,2.0,0.0),
		processus=(SCALAR,0.0,3.0,0.0),
		commun=(SCALAR,0.0,2.0,0.0),
		api=(SCALAR,0.0,1.0,0.0),
		setCam=(BOOLEAN,True)
		):
	
	canva= get_cams("complexification")
	tmpBox=canva.inset(0.35)
	insetCoef=0.1
	boxArray=[tmpBox.move_left(1.1),tmpBox,tmpBox.move_right(1.1)]
	add=" et au-del"
	titleArray=["Fractales "+add[0:int(len(add)*tii)],"Cas particuliers","Interfaces graphiques"]
	camArray=[boxArray[0].inset(insetCoef).move_down(0.06), boxArray[1].inset(insetCoef).move_down(0.06), boxArray[2].inset(insetCoef).move_down(0.06)]
	cp=camPath(canva, camArray[0], canva, camArray[1], canva, camArray[2], canva)
	
	if setCam:
		set_camera(cp(cam))
	else:
		set_camera(get_cams("current"))
	
	fontSize=canva.height()*textSize
	thicknessSize=canva.height()*0.005
	thickness(thicknessSize)
	tbox=titleBox(canva)
	p=get_middle(tbox)
	color(black,1)
	c=red.interp(black,clamp(multi-1))
	title1="Complexification"
#	title1="Modlisation procdurale"
#	title2=" multi-chelle"
#	text(p.x,p.y, [title1,c, title2[0:int(len(title2)*clamp(multi))]], timefont, size=canva.height()*titleSize)
	text(p.x,p.y, title1, timefont, size=canva.height()*titleSize)
	
	
	
	if des>epsilon:
		color(black,des)
		cx=[0.36,0.66]
		cy=[0.33,0.66]
		ctx=[0.18,0.5,0.85]
		cty=[0.2,0.5,0.85]
		tabBox=canva.bottom(0.8).inset(0.05)
		for i in range(0,2):
			thickness(thicknessSize*2.5)
			line(tabBox[0], tabBox[1]+tabBox.height()*(1-cy[i]), tabBox[0]+tabBox.width(), tabBox[1]+tabBox.height()*(1-cy[i]))
			thickness(thicknessSize)
			line(tabBox[0]+tabBox.width()*cx[i], tabBox[1], tabBox[0]+tabBox.width()*cx[i], tabBox[1]+tabBox.height())
		frame(tabBox)
		
		text(tabBox[0]+tabBox.width()*ctx[0], tabBox[1]+tabBox.height()*(1-cty[1]), "Simplification", timefont, size=fontSize, anchor='cc')
		text(tabBox[0]+tabBox.width()*ctx[0], tabBox[1]+tabBox.height()*(1-cty[2]), "Complexification", timefont, size=fontSize, anchor='cc')
		text(tabBox[0]+tabBox.width()*ctx[1], tabBox[1]+tabBox.height()*(1-cty[0]), "Langage\ndescriptif", timefont, size=fontSize, anchor='cc')
		text(tabBox[0]+tabBox.width()*ctx[2], tabBox[1]+tabBox.height()*(1-cty[0]), "Facilit\nd'utilisation", timefont, size=fontSize, anchor='cc')
		
		if showTab>epsilon:
			color(black,clamp(showTab-0)*des)
			text(tabBox[0]+tabBox.width()*ctx[1], tabBox[1]+tabBox.height()*(1-cty[1]), "lmentaire", timefont, size=fontSize, anchor='cc')
			color(black,clamp(showTab-1)*des)
			text(tabBox[0]+tabBox.width()*ctx[2], tabBox[1]+tabBox.height()*(1-cty[1]), "Grande", timefont, size=fontSize, anchor='cc')
			color(black,clamp(showTab-2)*des)
			text(tabBox[0]+tabBox.width()*ctx[1], tabBox[1]+tabBox.height()*(1-cty[2]), "Expressif\n(procdurale)", timefont, size=fontSize, anchor='cc')
			color(black,clamp(showTab-3)*des)
			text(tabBox[0]+tabBox.width()*ctx[2], tabBox[1]+tabBox.height()*(1-cty[2]), "Faible", timefont, size=fontSize, anchor='cc')
	
		if showdes>epsilon:
			a=Vec2(tabBox[0]+tabBox.width()*ctx[1], tabBox[1]+tabBox.height()*(1-((1-x1)*cty[1]+x1*cty[2])))
			b=Vec2(tabBox[0]+tabBox.width()*ctx[2], tabBox[1]+tabBox.height()*(1-((1-x2)*cty[1]+x2*cty[2])))
			decx=(b-a)*0.6
			decy=Vec2(decx.y,-decx.x)*0.4
			p1=a     -decy
			p2=a-decx-decy
			p3=a-decx+decy
			p4=a     +decy
			p5=b     +decy
			p6=b+decx+decy
			p7=b+decx-decy
			p8=b     -decy
			ppp=Path()
			ppp.moveto(p1.x,p1.y)
			ppp.curveto(p2.x,p2.y,p3.x,p3.y,p4.x,p4.y)
			ppp.lineto(p5.x,p5.y)
			ppp.curveto(p6.x,p6.y,p7.x,p7.y,p8.x,p8.y)
			ppp.lineto(p1.x,p1.y)
			color(purple,showdes*0.3*des)
			fill(ppp)
		
		if showArrow>epsilon:
			a=Vec2(tabBox[0]+tabBox.width()*ctx[2], tabBox[1]+tabBox.height()*(1-cty[1]))
			b=Vec2(tabBox[0]+tabBox.width()*ctx[2], tabBox[1]+tabBox.height()*(1-cty[2]))
			color(purple,showArrow*des)
			Vec2.arrow(b,a,thicknessSize*3)
	
	
	
#	color(coldic.font,build)
#	text(canva[0]+canva.width()*0.5,canva[1]+canva.height()*0.8,"Etat de l'art et contributions",timefont, size=fontSize, anchor='cc')
	
	for i in range(0,len(boxArray)):
		coef=pic(cam,i*2+1,1)
		color(black,build*(1-pic(cam,i*2+1,0.3)))
		frame(boxArray[i])
		s=0.8*fontSize*(1-coef)+ boxArray[i].inset(insetCoef).height()*titleSize*coef
		color(black,build)
		text(boxArray[i][0]+boxArray[i].width()*0.5, boxArray[i][1]+boxArray[i].height()*0.8,titleArray[i],timefont,anchor='cc', size=s, justify=0.5)
	
	if fractale>epsilon:
		subcanva=camArray[0]
		subfontSize=subcanva.height()*textSize
		subthicknessSize=wfunc(subcanva)
		thickness(subthicknessSize)
		
		upbox=scale_rect(subcanva,0.95,0.5).move_up(0.2).move_right(0.1)
		plusminusbox=upbox.left(0.04).move_right(2)
		pmb=Rect(plusminusbox[0],plusminusbox[1], width=plusminusbox.width(), height=plusminusbox.width())
		coef=plusminusbox.height()/6*0.8

		downbox=upbox.bottom(0.4).move_down(1.1).move_left(0.05)
		
		nbLine=6
		
		color(coldic.font,carac*fractale)
		text(upbox[0]+upbox.width()*0.02, upbox[1]+upbox.height(), "Caractristiques gnrales", timefont, size=subfontSize, anchor="tw")

		def draw_carac(i,s,b,alpha):
			box=pmb.move_up((1.6+nbLine-i)*coef,True)
			if b:
				color(green,alpha)
				draw_plus(box,subthicknessSize*2)
			else:
				color(red,alpha)
				draw_minus(box,subthicknessSize*2)
			color(coldic.font,alpha)
			text(box[0]+box.width(),box[1], s, timefont, size=subfontSize, anchor='cw',justify=1.0)
		
		color(coldic.font,carac*fractale)
		draw_carac(1,"Prcision infinie",True,carac*fractale)
		draw_carac(2,"Rptitivit",False,carac*fractale)
		draw_carac(3,"Manque de contrle",False,carac*fractale)
		draw_carac(4,"Pas anim",False,carac*fractale)
#		draw_carac(5,"Visu non adaptative",False,carac*fractale)
			
		tmpalpha=clamp(2-lsystem)*clamp(fractale)
		if tmpalpha>epsilon:
			color(black,tmpalpha)
			imBox=subcanva.inset(0.37).move_right(1.2).move_up(0.1)
			tmpBox=imBox.restrict_aspect(ims["f3"].aspect)
			box_image(tmpBox, ims["f3"],tmpalpha)
			frame(tmpBox)
			tmpBox=imBox.move_up(1.2).restrict_aspect(ims["f4"].aspect)
			box_image(tmpBox, ims["f4"], tmpalpha)
			frame(tmpBox)
		tmpalpha=pic(lsystem,2,0.5)*fractale
		if tmpalpha>epsilon:
			color(black,tmpalpha)
			imBox=subcanva.inset(0.37).move_right(1.2).move_up(0.1)
			tmpBox=imBox.restrict_aspect(ims["ifs"].aspect)
			box_image(tmpBox,ims["ifs"],tmpalpha)
			frame(tmpBox)
			tmpBox=imBox.move_up(1.2).restrict_aspect(ims["lsys"].aspect)
			box_image(tmpBox,ims["lsys"],tmpalpha)
			frame(tmpBox)

		
		if lsystem>epsilon:
			alpha1=clamp(lsystem)*fractale*clamp(3-lsystem)
			color(coldic.font,alpha1)
			p=getRelPos(subcanva,0.05,0.44)
			text(p.x, p.y, "- Fractales trs spcialises", timefont, size=subfontSize, anchor="tw")
			text(p.x+subfontSize, p.y-subfontSize, "- Ensemble de Mandelbrot [Mandelbrot75,Colonna89]\n- Markus-Lyapunov...", timefont, size=subfontSize, anchor="tw")
			p.y-=3.2
			alpha2=clamp(lsystem-1)*fractale*clamp(3-lsystem)
			color(coldic.font,alpha2)
			text(p.x, p.y, "- Outils plus gnriques",timefont,size=subfontSize, anchor="tw")
			text(p.x+subfontSize, p.y-subfontSize, "- L-systme [Lindenmayer76]\n- IFS [Huntchinson81]",timefont,size=subfontSize, anchor="tw")

			tmpBox=Rect(downbox[0]+0.5*downbox.width(), downbox[1]+0.3*downbox.height(), width=downbox.width()*0.06, height=downbox.height()*0.08)
		
		if cpfg>epsilon:
			color(coldic.font,cpfg*fractale)
			box=scale_rect(pmb.move_up((1.6+nbLine-2.7)*coef,True),1,3)
			box=box.move_right(10.0)
			draw_acco(box,wfunc(subcanva))
			text(box[0]+box.width()*2, box[1]+1.0*box.height(), "[Prusinkiewicz]",timefont,size=subfontSize, anchor="cw")
			c1=Color(coldic.font,clamp(cpfg)*fractale)
			c2=Color(purple,clamp(cpfg)*fractale)
			text(box[0]+box.width()*2.5, box[1]+0.2*box.height(), [c1,"- L-studio\n - Sub-Lsystem\n- L+C\n"],timefont,size=subfontSize, anchor="cw")
		
		if platonic>epsilon:
			color(coldic.font,clamp(platonic))
			p=Vec2(subcanva[0]+subcanva.width()*0.03, subcanva[1]+subcanva.height()*0.8)
			text(p.x, p.y, "L-systmes tendus :"  , timefont ,size=subfontSize, anchor="tw")
			txt="""- L-studio [Prusinkiewicz99] : outil de modlisation
- sub-l-system [Mech03] : modles plus varis
- L+C [Karwowski03]: plus expressif
"""
			text(p.x+subfontSize, p.y-subfontSize, txt , timefont ,size=subfontSize, anchor="tw")
			
			color(purple,clamp(platonic-1))
			txt="""Platonic World :
"un monde o n'existe que ce que l'on observe"
"""
			text(subcanva[0]+subcanva.width()*0.5, subcanva[1]+subcanva.height()*0.5, txt, timefont ,size=subfontSize, anchor="tc", justify=0.5)
			
			color(purple,clamp(platonic-2))
			color(black,clamp(platonic-2))
			p=Vec2(subcanva[0]+subcanva.width()*0.3, subcanva[1]+subcanva.height()*0.35)
			text(p.x, p.y, "Notre approche :"  , timefont ,size=subfontSize, anchor="tw")
			txt="""- 2D => 3D
- Gestion de l'animation
- Langage utilis : C++
"""
			text(p.x+subfontSize, p.y-subfontSize, txt , timefont ,size=subfontSize, anchor="tw")
			
	
	if particulier>epsilon:
		subcanva=camArray[1]
		subfontSize=subcanva.height()*textSize
		subthicknessSize=wfunc(subcanva)
		thickness(subthicknessSize)
		
		color(coldic.font,particulier*(1-picture))
		box=subcanva.restrict_aspect( xfig_particulier.base.aspect()).outset(0.15).move_down(0.2)
		box2=subcanva.restrict_aspect( xfig_particulier2.base.aspect()).inset(0.1).move_up(0.7)
		xfig_particulier.set(box)
		xfig_particulier2.set(box2)

		for i in particulier_txt:
			tmpBox= xfig_particulier.get(i).interp(xfig_particulier2.get(i),picture)
			box_image(tmpBox,ims[i],particulier)
			text(tmpBox[0]+tmpBox.width()*0.5, tmpBox[1], particulier_txt[i], timefont, size=subfontSize, anchor="bc")
		
		color(purple,pic(picture,1,0.2))
		text(box2[0]+box2.width()*0.5, box2[1]-subfontSize*0.1, "Environnement de travail", timefont, size=subfontSize, anchor='cc')
		
		
		color(coldic.font,particulier*particulier_t)
		box=scale_rect(subcanva.bottom(0.3).move_up(0.7),0.9,1)
		box1=box.left(0.5).move_left(0.2).restrict_aspect(1)
		if particulier_t>epsilon:
			facto(box1,case,dg,subthicknessSize,subfontSize, particulier*particulier_t)
			color(coldic.font,particulier*clamp(dg-1))
			text(box1[0]+box1.width()*0.8, box[1]-1.5*subfontSize, "Factorisation\ndes tches communes", timefont, size=subfontSize, anchor='tc')
		
		box2=box.right(0.5)
		color(coldic.font,particulier*clamp(commun))
		text(box2[0]+box2.width()*0.5, box2[1]-1.5*subfontSize, "Intgration des modles", timefont, size=subfontSize, anchor='tc')
		box2=box2.restrict_aspect(1.5).outset(0.15)
		
		a={}
		a["plante"]=box2.inset(0.35).move_up(0.7)
		a["prairie"]=a["plante"].move_down(2.0).move_left(1.2)
		a["ocan"]=a["plante"].move_down(2.0)
		a["ville"]=a["plante"].move_down(2.0).move_right(1.2)
		for i in a:
			if i!="plante":
				m=get_middle(a[i])
				text(m.x,m.y,i,timefont,size=subfontSize*0.8,anchor='cc')
				frame(a[i])

		color(coldic.font,particulier*clamp(commun-1))
		frame(a["plante"])
		m=get_middle(a["plante"])
		text(m.x,m.y,"plante",timefont,size=subfontSize*0.8,anchor='cc')
		p=get_middle
		for i in a:
			if i!="plante":
				line(a["plante"][0]+a["plante"].width()*0.5, a["plante"][1], a[i][0]+a[i].width()*0.5, a[i][1]+a[i].height())
		
	
	if api>epsilon:
		subcanva=camArray[2]
		subfontSize=subcanva.height()*textSize
		subthicknessSize=wfunc(subcanva)
		thickness(subthicknessSize)
		
		color(coldic.font,api)
		box=subcanva.top(0.6).inset(0.2).move_down(0.15)
		box=box.restrict_aspect( xfig_mod.base.aspect())
		xfig_mod.set(box)
		for i in xfig_mod.listBox:
			tmpBox=xfig_mod.get(i)
			if i=="txt_bonzai":
				p=get_middle(tmpBox)
				text(p.x,p.y,"[Boudon03]",timefont,  anchor='cc', size=subfontSize)
			elif i=="txt_hair":
				p=get_middle(tmpBox)
				text(p.x,p.y,"[Kim02]",timefont,  anchor='cc', size=subfontSize)
			else:
				box_image(tmpBox,ims[i],api)
				
		
		alpha=api*processus0
		color(coldic.font,alpha)
		box=subcanva.inset(0.465).move_down(2.4).move_right(1)
		res=draw_processus(box,subthicknessSize,1.0,alpha)
		text(res["center"].x,res["center"].y-res["rayon"]*1.3, "Processus de cration",timefont,size=subfontSize,anchor='cc')
		
		color(coldic.font,alpha)
		tbox=subcanva.left(0.3).bottom(0.3)
		angle1=(res["begin"]-10)/360.0*6.28
		angle2=(res["begin"]-90)/360.0*6.28
		r=res["rayon"]*0.2
		color(black,api*clamp(processus-1))
		p=Vec2(res["center"].x+res["rayon"]*cos(angle1), res["center"].y+res["rayon"]*sin(angle1))
		color(purple,alpha)
		dot(r, p.x,p.y)
#		text(p.x+r,p.y-r,"Interface",timefont, size=subfontSize*0.5, anchor='cw')
		
		txt=[ Color(coldic.font,api*clamp(processus)) , "- Structure multi-chelle\n(pas d'affichage multi-chelle)\n\n", Color(coldic.font,api*clamp(processus-1)), "- Modlisation du plus grossier au plus fin:\ncomplmentaire avec notre approche"]
		text(tbox[0]+2.5*subfontSize,tbox[1]+tbox.height(), txt, timefont, size=subfontSize, anchor='cw')




def get_pros_from_vision(v):
	return v.outset(0.6).move_left(0.4)




def ArtBilan(
		alphaTitle=(SCALAR,0.0,1.0,0.0),
		showTxt=(SCALAR,0.0,1.0,0.0),
		txt=(SCALAR,0.0,1.0,0.0)):
	cams["processus"]= get_cams("vision")
	canva=cams["processus"]
	set_camera(canva)
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	
	title(canva,"tat de l'art : bilan",alphaTitle)
	
	dec=fontSize*1.3
	p=getRelPos(canva,0.07,0.7)
	color(black,clamp(txt-0)*showTxt)
	text(p.x,p.y,"- Mthodes de simplification : insuffisantes",timefont,size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-1)*showTxt)
	text(p.x,p.y,"- Approche choisie : complexification",timefont,size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-2)*showTxt)
	text(p.x,p.y,"- Complexification => modlisation procdurale",timefont,size=fontSize, anchor='tw')
	color(black,clamp(txt-3)*showTxt)
	p=getRelPos(canva,0.5,0.3)
	res=text(p.x,p.y,"Ajout de prcision jusqu' satisfaire\nla prcision requise par l'observation",timefont,size=fontSize, anchor='cc')
	color(red,clamp(txt-3)*showTxt*0.3)
	txt_frame(res)


angleValue=[0.29,0.6,1.0,1.6]
def FourPage(
		alphaTitre=(SCALAR,0.0,1.0,0.0),
		zoom=(SCALAR,0.0,1.0,0.0),
		arc=(SCALAR,0.0,1.0,0.0),
		adaptatif=(SCALAR,0.0,1.0,0.0),
		adaptatif2=(SCALAR,0.0,1.0,0.0),
		pb=(SCALAR,0.0,2.0,0.0),
		solution=(SCALAR,0.0,1.0,0.0),
		angle=(SCALAR,angleValue[0],angleValue[3],angleValue[0]),
		alphacircle=(SCALAR,0.0,1.0,0.0),
		echantillon=(SCALAR,0.0,2.0,0.0),
		antialiasing=(SCALAR,0.0,1.0,0.0),
		simplification=(SCALAR,0.0,1.0,0.0),
		complexification=(SCALAR,0.0,1.0,0.0)
		):
	cams["processus"]= get_pros_from_vision(get_cams("vision"))
	canva=cams["processus"]
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	test=Rect(0.0,0.0,100,100)

	createur_box=get_oeil_box2(get_cams("vision"))
	createur_box=createur_box.move_right(0.5).move_down(0.5).outset(0.2)

	rayon=createur_box.width()*1.5
	center=get_middle(createur_box)
	pos_curve=Vec2(center.x-rayon*1.2,center.y-rayon*0.1)
	def fn_pos_ecran(angle):
		return Vec2(pos_curve.x+rayon*0.8*cos(3.14*angle), pos_curve.y+rayon*0.8*sin(3.14*angle))

	pos_ecran=fn_pos_ecran(angleValue[0])
	cams["aliasing"]= Rect(pos_ecran.x,pos_ecran.y,width=rayon*0.1,height=rayon*0.1)

	pos_antialias=fn_pos_ecran(angleValue[1])
	cams["antialiasing"]= Rect(pos_antialias.x, pos_antialias.y, width=rayon*0.1, height=rayon*0.1)

	pos_simp=fn_pos_ecran(angleValue[2])
	cams["simplification"]= Rect(pos_simp.x, pos_simp.y, width=rayon*0.1, height=rayon*0.1)

	pos_comp=fn_pos_ecran(angleValue[3])
	cams["complexification"]= Rect(pos_comp.x, pos_comp.y, width=rayon*0.1, height=rayon*0.1)

	if zoom<0.99:
		cams["current"]=canva.interp(get_cams("vision"),1-zoom)
	elif echantillon>epsilon:
		cams["current"]=canva.interp(get_cams("aliasing"),clamp(echantillon))
	elif antialiasing>epsilon:
		cams["current"]=canva.interp(get_cams("antialiasing"),clamp(antialiasing))
	elif simplification>epsilon:
		cams["current"]= canva.interp(get_cams("simplification"),clamp(simplification))
	elif complexification>epsilon:
		cams["current"]= canva.interp(get_cams("complexification"), clamp(complexification))
	else:
		cams["current"]=canva
	
	set_camera(get_cams("current"))
	
	thickness(get_cams("vision").height()*0.005)
	res=createurEtSapin(get_oeil_box2(get_cams("vision")),zoom)
	box=titleBox(canva)
	middle=get_middle(box)
	text(middle.x,middle.y,"Processus de cration", timefont, size=canva.height()*titleSize, justify=0.5)
	
	
	if adaptatif>epsilon:
		txt="Prcision adaptative"
		p=getRelPos(canva,0.23,0.25)
		color(black,adaptatif)
		res=text(p.x, p.y, txt, timefont, size=fontSize,anchor='cc')
		color(red,adaptatif*0.3)
		txt_frame(res)
	
	if adaptatif2>epsilon:
		txt="Observation"
		p=get_middle(canva.inset(0.4).move_left(1.2).move_up(0.3))
		color(black,adaptatif2)
		Vec2.arrow(p-Vec2(0,fontSize*0.1), pos_curve+Vec2(-1,0.1)*(rayon*1.1),thicknessSize)
		text(p.x, p.y, txt, timefont, size=fontSize,anchor='bc')
		
	
	color(black,1)
	
	arcProcess(pos_curve,rayon,arc,thicknessSize*3)
	
#	if arc>epsilon:
#		arcshape=Path()
#		arcshape.arcn(pos_curve.x,pos_curve.y,340,340-arc*280,rayon)
#		widestroke(arcshape,thicknessSize*3)
#		arrow(arcshape,(0,rayon*0.2,rayon*0.2))
	
	if arc>0.2:
		color(coldic.font,clamp(arc-0.2)*4)
		text(pos_curve.x, pos_curve.y-rayon*1.2,"Modlisation", timefont, size=fontSize, justify=0.5,anchor='cc')
		color(coldic.font,1.0)
	
	if arc>0.7:
		color(coldic.font,clamp(arc-0.7)*4)
		text(pos_curve.x, pos_curve.y+rayon*1.2,"Rendu", timefont, size=fontSize, justify=0.5,anchor='cc')
		color(coldic.font,1.0)
	
	thickness(thicknessSize)
	pb_box=createur_box.move_left(5.0).move_up(1.0)
	middle=get_middle(pb_box)
	color(red,pic(pb,1,0.2,1))
	text(middle.x,middle.y,"O la multi-chelle\npose problme ?", timefont, size=fontSize, justify=0.5)
	color(red,pic(pb,3,0.2))
	text(middle.x,middle.y,"Solution ?", timefont, size=fontSize, justify=0.5)
	
	color(red,alphacircle)
	tmp_pos=fn_pos_ecran(angle)
	circle(rayon*0.1,tmp_pos.x,tmp_pos.y)

	color(red,pic(pb,2,0.2))
	text(pos_ecran.x-rayon*0.3,pos_ecran.y-rayon*0.15,"cran", timefont, size=fontSize)
	
	color(red,alphacircle*pic(angle,angleValue[1],0.05))
	text(pos_ecran.x-rayon*0.4,pos_ecran.y-rayon*0.15,"Anti-aliasing", timefont, size=fontSize)

	color(red,alphacircle*pic(angle,angleValue[2],0.05))
	text(pos_simp.x+rayon*0.2,pos_simp.y,"Simplification", timefont, size=fontSize, anchor="cw")

	color(red,alphacircle*pic(angle,angleValue[3],0.05))
	text(pos_comp.x+rayon*0.45,pos_comp.y+rayon*0.3,"Complexification", timefont, size=fontSize, anchor="ce")
