#from slithy.presentation import *
from slithy.library import *
from math import *
import re
import os

def playWav(filename):
#	return os.popen2("soundwrapper play "+filename)
	return None

timefont=load_font( 'minion.slf' )

def window_aspect():
	return Rect(visible()).aspect()

def getRelPos(box,x,y):
	return Vec2(box[0]+x*box.width(),box[1]+y*box.height())

class camPath:
	def __init__(self,*boxes):
		self.boxes=boxes
	def __call__(self,w):
		iw=int(w)
		if iw<0:
			return self.boxes[0]
		if iw>=(len(self.boxes)-1):
			return self.boxes[len(self.boxes)-1]
		coef=w-iw
		return self.boxes[iw].interp(self.boxes[iw+1],coef)

class Vec2:
	def __init__(self,x,y):
		self.x=x
		self.y=y
	def __repr__( self ):
		return "Vec2("+str(self.x)+","+str(self.y)+")"
	def normalise(self):
		n=self.norm()
		return Vec2(self.x/n,self.y/n)
	def norm(self):
		return sqrt(self.x*self.x+self.y*self.y)
	def angle(self):
		v=self.normalise()
		a=acos(v.x)
		if asin(v.y)<0:
			return a
		else:
			return -a
	def __sub__(self,other):
		return Vec2(self.x-other.x,self.y-other.y)
	def __add__(self,other):
		return Vec2(self.x+other.x,self.y+other.y)
	def scale(self,s):
		self.x=self.x*s
		self.y=self.y*s
	def __mul__(self,s):
		return Vec2(self.x*s,self.y*s)
	def line(p1,p2):
		line(p1.x,p1.y,p2.x,p2.y)
	def arrow(p1,p2,w):
		draw_arrow(p1.x,p1.y,p2.x,p2.y,w,w*3)


def get_middle(r):
	return Vec2(r[0]+r.width()*0.5,r[1]+r.height()*0.5)

def box_image(r,i,alpha=1.0):
	p=get_middle(r)
	res=image(p.x,p.y,i,width=r.width(),height=r.height(),alpha=alpha)
	return Rect(res["left"],res["bottom"],res["right"],res["top"])

def scale_rect(r,sx,sy):
	p=get_middle(r)
	w=r.width()*sx
	h=r.height()*sy
	return Rect(p.x,p.y,width=w,height=h)

def titleBox(r):
	return r.top(0.2).move_down(0.15)


def clamp(s):
	if s<0: return 0
	if s>1: return 1
	return s

def pic(x,p,m=0.1,l=0.0):
	if x<p-m:
		return 0
	elif x<p:
		return (m-(p-x))/m
	elif x<p+l:
		return 1
	elif x<p+l+m:
		return (m+(p+l-x))/m
	else:
		return 0

def Ecran(canva,nbLine,complete):
	w=canva.width()
	h=canva.height()
	for i in range(0,nbLine*complete):
		for j in range(0,nbLine*complete):
			p=Vec2((i*1.0)/nbLine,(j*1.0)/nbLine)
			line(canva[0]+p.x*w, canva[1], canva[0]+p.x*w, canva[1]+h)
			line(canva[0], canva[1]+p.y*h, canva[0]+w, canva[1]+p.y*h)




implyPath=Path()
implyPath.moveto(0,0)
implyPath.lineto(1,0)
implyPath.moveto(0,1)
implyPath.lineto(1,1)
implyPath.moveto(2.5/3,1.5)
implyPath.lineto(3.5/3,0.5)
implyPath.lineto(2.5/3,-0.5)
def draw_imply(r,w):
	push()
	translate(r[0],r[1])
	scale(r.width(),r.height())
	widestroke(implyPath,w/r.width())
	pop()

equivPath=Path()
equivPath.moveto(0,0)
equivPath.lineto(1,0)
equivPath.moveto(0,1)
equivPath.lineto(1,1)
equivPath.moveto(2.5/3,1.5)
equivPath.lineto(3.5/3,0.5)
equivPath.lineto(2.5/3,-0.5)
equivPath.moveto(0.5/3,1.5)
equivPath.lineto(-0.5/3,0.5)
equivPath.lineto(0.5/3,-0.5)
def draw_equiv(r,w):
	push()
	translate(r[0],r[1])
	scale(r.width(),r.height())
	widestroke(equivPath,w/r.width())
	pop()

crossPath=Path()
crossPath.moveto(0,0)
crossPath.lineto(1,1)
crossPath.moveto(1,0)
crossPath.lineto(0,1)
def draw_cross(r,w):
	push()
	translate(r[0],r[1])
	scale(r.width(),r.height())
	widestroke(crossPath,w/r.width())
	pop()

def get_square(p,r):
	return Rect(p.x-r/2,p.y-r/2,p.x+r/2,p.y+r/2)

plusPath=Path()
plusPath.moveto(-1,0)
plusPath.lineto(1,0)
plusPath.moveto(0,-1)
plusPath.lineto(0,1)
def draw_plus(r,w):
	push()
	translate(r[0],r[1])
	scale(r.width()*0.5,r.height()*0.5)
	widestroke(plusPath,w/r.width())
	pop()

accoPath=Path()
accoPath.moveto(0,4)
accoPath.qcurveto(1,4,1,3)
accoPath.qcurveto(1,2,2,2)
accoPath.qcurveto(1,2,1,1)
accoPath.qcurveto(1,0,0,0)
def draw_acco(r,w):
	push()
	translate(r[0],r[1])
	scale(r.width()*0.5,r.height()*0.25)
	widestroke(accoPath,w/r.width())
	pop()

minusPath=Path()
minusPath.moveto(-0.7,0)
minusPath.lineto(0.7,0)
def draw_minus(r,w):
	push()
	translate(r[0],r[1])
	scale(r.width()*0.5,r.height()*0.5)
	widestroke(minusPath,w/r.width())
	pop()

def draw_arrow(p1x,p1y,p2x,p2y,w1,w2=-1):
	if w2==-1:
		w2=3*w1
	tmpPath=Path()
	tmpPath.moveto(p1x,p1y)
	tmpPath.lineto(p2x,p2y)
	widestroke(tmpPath,w1)
	arrow(tmpPath,(0,w2,w2))



def multi_text(x,y,txt,font,size,an,ecart=0):
	prog = re.compile(r"\n")
	tabSize=size*2
	listLine=prog.split(txt)
	count=0
	for line in listLine:
		if len(line)>0:
			n=0
			while n<len(line) and line[n]=='\t':
				n=n+1
			text(x+n*tabSize, y-(1+ecart)*count*(size), line[n:len(line)], font, size=size, anchor=an)
		count=count+1

def Slide_over():
	canva= Rect(visible())
	set_camera(canva)
	fontSize=canva.height()*0.1
	p=get_middle(canva)
	color(red)
	text(p.x,p.y, "Over", timefont, size=fontSize,anchor='cc')
	


class XfigFrame:
	def __init__(self,r=None):
		self.base=r
		self.listBox={}
	def set(self,box):
		self.box=box
		self.xcoef=self.box.width()/self.base.width()
		self.ycoef=self.box.height()/self.base.height()
	def get(self,i):
		if not i in self.listBox:
			 raise ValueError, i+" not in listBox"
		p1=Vec2(self.box[0]+ (self.listBox[i][0]-self.base[0])*self.xcoef, self.box[1]+self.box.height()-(self.listBox[i][1]-self.base[1])*self.ycoef)
		p2=Vec2(self.box[0]+(self.listBox[i][2]-self.base[0])*self.xcoef, self.box[1]+self.box.height()-(self.listBox[i][3]-self.base[1])*self.ycoef)
		return Rect(p1.x,p1.y,p2.x,p2.y)
	def load(self,fname):
		regex=re.compile(r"^# (.*)$\n(?:^.*$\n)(?:^.*$\n)?^\t (-?[0-9]+) (-?[0-9]+) (-?[0-9]+) (-?[0-9]+) (-?[0-9]+) (-?[0-9]+) (-?[0-9]+) (-?[0-9]+) (-?[0-9]+) (-?[0-9]+)$",re.MULTILINE)
		f=file(fname)
		content=f.read()
		res=regex.findall(content)
		bref=[int(res[0][1]),int(res[0][2]),int(res[0][3]),int(res[0][6])]
		for bb in res:
			b=[int(bb[1]),int(bb[2]),int(bb[3]),int(bb[6])]
			if bref[0]>b[0]:
				bref[0]=b[0]
			if bref[1]>b[1]:
				bref[1]=b[1]
			if bref[2]<b[2]:
				bref[2]=b[2]
			if bref[3]<b[3]:
				bref[3]=b[3]
			self.listBox[bb[0]]=b
		r=Rect(bref[0],bref[1],bref[2],bref[3])
		self.base=r
	def draw(self):
		for i in self.listBox:
			box=self.get(i)
			color(blue,1)
			frame(box)
			color(red,1)
			text(box[0],box[1],i,timefont, size=self.box.height()*0.05, anchor='tw')


def pixel(box):
	line(box[0], box[1]-box.height()*0.1, box[0], box[1]+box.height()*1.1)
	line(box[0]+box.width(), box[1]-box.height()*0.1, box[0]+box.width(), box[1]+box.height()*1.1)
	line(box[0]-box.width()*0.1, box[1], box[0]+box.width()*1.1, box[1])
	line(box[0]-box.width()*0.1, box[1]+box.height(), box[0]+box.width()*1.1, box[1]+box.height())


























