import random
from math import *
import sys

from slithy.library import *

from common import *
from ressource import *

def draw_interval(x1,x2,hline):
	h=(x2-x1)*0.1
	line(x1, hline, x2, hline)
	line(x1,hline-h,x1,hline+h)
	line(x2,hline-h,x2,hline+h)
	
def draw_yinterval(x1,x2,hline):
	h=(x2-x1)*0.1
	line(hline,x1, hline,  x2)
	line(hline-h,x1,hline+h,x1)
	line(hline-h,x2,hline+h,x2)

class Rot:
	observateurRotation=0
	def __init__(self,init=0):
		self.observateurRotation=0
	def inc(self,i):
		self.observateurRotation+=i
		if self.observateurRotation>3.14:
			self.observateurRotation-=6.28
		if self.observateurRotation<-3.14:
			self.observateurRotation+=6.28
	def get(self,):
		return self.observateurRotation
rot=Rot()

def snowFonc(box,p=1):
	h=box.height()
	w=box.width()
	tier=1.0/3
	line(box[0], box[1], box[0]+w*tier, box[1], box[0]+w*0.5, box[1]+p*h, box[0]+2*w*tier, box[1], box[0]+w, box[1])

class Uturn:
	a=3.14/6
	k1=Vec2(cos(a), sin(a))
	k2=Vec2(k1.x,-k1.y)
	path=Path()
	pp0=k1
	path.moveto(pp0.x,pp0.y)
	pp1=k1*3
	pp2=k2*3
	pp3=k2*1.3
	path.curveto(pp1.x,pp1.y,pp2.x,pp2.y,pp3.x,pp3.y)
	def draw(self,center,h,w):
		thickness(w)
		push()
		translate(center.x,center.y)
		scale(h)
		a=3.14/6
		widestroke(self.path,w/h)
		arrow(self.path,(0,w/h*5,w/h*5))
		pop()
		
uturn=Uturn()

def draw_snowNode(tmpBox,w,avan,alpha=1):
	color(coldic.classe,alpha)
	center=get_middle(tmpBox)
	center.x-=tmpBox.width()*0.2
	h=tmpBox.height()*0.5
	thickness(w)
	circle(h,center.x,center.y)
	
	color(black,alpha)
	uturn.draw(center,h,w)
	tmpBox.top(0.3).inset(0.2)
	snowFonc(Rect(center.x,center.y,width=h*1.3,height=h*0.7),avan)



#second page: les 5 sens
def dgCritere(
		tit=(SCALAR,0,1.0,0.0),
		txt=(SCALAR,0,1.0,0.0),
		screen=(SCALAR,0,1.0,0.0),
		gra=(SCALAR,0,1.0,0.0),
		slide1=(SCALAR,0,1.0,0.0),
		slide2=(SCALAR,0,1.0,0.0)):
	canva=get_cams("evaluation")
	sc1=canva.left(0.5).restrict_aspect(window_aspect()). inset(0.2).move_down(0.7)
	sc2=canva.right(0.5).restrict_aspect(window_aspect()). inset(0.2).move_down(0.7)
	cam=canva
	if slide1>epsilon:
		cam=canva.interp(sc1.inset(0.1),slide1)
	elif slide2>epsilon:
		cam=canva.interp(sc2.inset(0.1),slide2)
	
	set_camera(cam)
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	color(coldic.font,tit)
	
	title(canva,"Critres d'arrt")
	
	dec=1.5*fontSize
	p=Vec2(canva[0]+canva.width()*0.1,canva[1]+canva.height()*0.8)
	color(black,clamp(txt-0))
	text(p.x,p.y,"- Scne 3D potentiellement infinie",timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-1))
	text(p.x,p.y,"- Observation => critres d'arrt",timefont, size=fontSize, anchor='tw')
	
	graphbox=canva.right(0.3).bottom(0.6).inset(0.1)
	draw_graph_main(1, graphbox, 5, thicknessSize*4, 1, 3.14, gra)

	p.y-=dec
	color(black,clamp(txt-2))
	text(p.x,p.y,["- ",Color(blue,clamp(txt-2)),"Prcision",RESET," : taille suffisante ?"],timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-3))
	text(p.x,p.y,["- ",Color(blue,clamp(txt-3)),"Visibilit",RESET," : non occult ?"],timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-4))
	ttt="Nombre d'objets affichs\nproportionnels\nau nombre de pixels"
	res=text(p.x+2*fontSize,p.y-1*fontSize,ttt,timefont, size=fontSize, anchor='tw', justify=0.5)
	color(red,clamp(txt-4)*0.3)
	txt_frame(res,0.1)
	
	color(black,screen)
	frame(sc1)
	frame(sc2)
	p1=get_middle(sc1)
	p2=get_middle(sc2)
	color(blue,screen*(1-clamp(max(slide1,slide2))))
	text(p1.x,p1.y,"Prcision",timefont, size=fontSize, anchor='cc')
	text(p2.x,p2.y,"Visibilit",timefont, size=fontSize, anchor='cc')

#second page: les 5 sens
def dgVisibilite0(
		tit=(SCALAR,0,1.0,0.0),
		txt=(SCALAR,0,1.0,0.0)):
	canva=get_cams("evaluation")
	set_camera(canva)
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	color(coldic.font,tit)
	
	title(canva,"Visibilit : motivations")
	
	dec=1.5*fontSize
	p=Vec2(canva[0]+canva.width()*0.2,canva[1]+canva.height()*0.7)
	color(black,clamp(txt-0))
	text(p.x,p.y,"- Algorithme temps-rel",timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-1))
	text(p.x,p.y,"- Structure dynamique => pas de prcalcul",timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-2))
	text(p.x,p.y,"- Scnes animes",timefont, size=fontSize, anchor='tw')

#second page: les 5 sens
def dgVisibilite2(
		tit=(SCALAR,0,1.0,0.0),
		gra=(SCALAR,0,1.0,0.0),
		txt=(SCALAR,0,1.0,0.0)):
	canva=get_cams("evaluation")
	set_camera(canva)
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	color(coldic.font,tit)
	
	title(canva,"Visibilit : bilan")
	
	dec=1.5*fontSize
	p=Vec2(canva[0]+canva.width()*0.07,canva[1]+canva.height()*0.8)
	color(black,clamp(txt-0))
	text(p.x,p.y,"- Concept trs simple (botes englobantes)",timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-1))
	text(p.x,p.y,"- Paralllisme CPU/GPU => lourdes rpercussions",timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-2))
	text(p.x,p.y,"- Performances (Cube de Sirpienski)",timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-3))
	text(p.x,p.y,"- Taux de remplissage de l'cran dans un cas extrme",timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-3))
	text(p.x+3*fontSize,p.y,"- Sans : 200 crans",timefont, size=fontSize, anchor='tw')
	p.y-=dec
	color(black,clamp(txt-3))
	text(p.x+3*fontSize,p.y,"- Avec : 20 crans (dont 12 pour la visibilit)",timefont, size=fontSize, anchor='tw')
	
	color(black,gra)
	imbox=canva.bottom(0.5).restrict_aspect(ims["tab.jpg"].aspect)
	imbox=imbox.inset(0.15).move_up(0.2)
	box_image(imbox,ims["tab.jpg"],gra)
	a=getRelPos(imbox,0,1.2)
	b=getRelPos(imbox,0.5,-0.02,)
	c=getRelPos(imbox,0.2,0.25,)
	d=getRelPos(imbox,0.5,0.65)
	fc=0.7
	text(a.x,a.y,"temps d'affichage\nen milli-seconde", timefont, size=fontSize*fc, anchor='tc')
	text(b.x,b.y,"Distance logarithmique\n l'objet le plus proche", timefont, size=fontSize*fc, anchor='tc')
	text(c.x,c.y,"Avec", timefont, size=fontSize*fc, anchor='cc')
	text(d.x,d.y,"Sans", timefont, size=fontSize*fc, anchor='cc')

#second page: les 5 sens
def dgFirst(
		bar=(SCALAR,0,1.0,0.0),
		nomansland=(SCALAR,0,1.0,0.0),
		ti=(SCALAR,0,2.0,0.0),
		showsegment=(SCALAR,0,1.0,0.0),
		showfrac=(SCALAR,0,1.0,0.0),
		snow_f=(SCALAR,0,1.0,0.0),
		fracPrecision=(SCALAR,0,1.0,0.0),
		rotation=(SCALAR,-10,10,0.0),
		adaptatif=(SCALAR,0,1.0,0.0),
		showVueTxt=(SCALAR,0,1.0,0.0),
		vueTxt=(SCALAR,0,1.0,0.0),
		segment=(SCALAR,-0.5,1.0,0.0),
		tree=(SCALAR,0,2.0,0.0),
		graphRot=(SCALAR,-1,1,0.0),
		continu=(BOOLEAN,False)
	):
	canva=get_cams("part2")
	set_camera(canva)
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	color(coldic.font,1)

	if showVueTxt>epsilon:
		box=canva.top(0.6).inset(0.1).move_down(0.06)
		box=box.restrict_aspect( xfig_bande.base.aspect())
		xfig_bande.set(box)
		for i in xfig_bande.listBox:
			tmpBox=xfig_bande.get(i)
			box_image(tmpBox,ims[i],showVueTxt)
		
		ydec=1.2
		color(black,showVueTxt*clamp(vueTxt-0))
		res=text(canva[0]+canva.width()*0.5, box[1]-0.5*fontSize, [Color(black,showVueTxt*clamp(vueTxt-0)), "Outil gnrique pour la ", Color(purple,showVueTxt*clamp(vueTxt-0)), "complexification"], timefont, size=fontSize, anchor='cc')
		p=Vec2(canva[0]+canva.width()*0.2, box[1]-fontSize)
		color(black,showVueTxt*clamp(vueTxt-1))
		p.y-=fontSize*ydec
		text(p.x, p.y, "- Nouveau formalisme", timefont, size=fontSize, anchor='cw')
		color(black,showVueTxt*clamp(vueTxt-2))
		p.y-=fontSize*ydec
		text(p.x, p.y, "- Environnement de travail", timefont, size=fontSize, anchor='cw')
		color(black,showVueTxt*clamp(vueTxt-3))
		p.y-=fontSize*ydec
		text(p.x, p.y, "- Calcul automatique de", timefont, size=fontSize, anchor='cw')
		color(black,showVueTxt*clamp(vueTxt-3))
		p.x+=fontSize*1.5
		p.y-=fontSize*ydec
		text(p.x, p.y, "- La prcision", timefont, size=fontSize, anchor='cw')
		p.y-=fontSize*ydec
		text(p.x, p.y, "- La visibilit", timefont, size=fontSize, anchor='cw')

	ta=["Cahier des charges","vue d'ensemble"]
	sss=ta[0][0:int(len(ta[0])*(1-clamp(ti)))]+ ta[1][0:int(len(ta[1])*(clamp(ti-1)))]
	title(canva,"DynamicGraph : "+sss)
	rot.inc(0.03*rotation)
	
	barBox=canva.bottom(0.3).inset(0.2).restrict_aspect(10.0).move_down(0.5)
	res=PrecisionBar(barBox,0.4,0.6,bar)
	
	segmentSize=barBox.width()/12
	first=res["gros"][0]+res["gros"].width()*(segment-0.1)
	current=first
	hline=barBox[1]+barBox.height()*2
	color(coldic.font,showsegment*bar)
	text(first-4*fontSize,hline+fontSize*0.2,"Reprsentation grossire", timefont, size=fontSize, anchor='bc', justify=0.5)
	color(purple,showsegment*bar)
	limitx=res["petit"][0]+res["petit"].width()
	count=0
	if current-segmentSize<limitx:
		current=limitx+segmentSize
		color(red,showsegment*bar)
		draw_interval(current,current-segmentSize, hline)
		harrow=barBox[1]+barBox.height()*1.5
		color(coldic.font,showsegment*bar)
		draw_arrow_2lines(Vec2(current,harrow), Vec2(res["ok"][0]+ res["ok"].width()*0.5, barBox[1]+barBox.height()), thicknessSize,thicknessSize*3)
	else:
		while current-segmentSize>limitx:
			draw_interval(current,current-segmentSize, hline)
			current=current-segmentSize
			count=count+1
		harrow=barBox[1]+barBox.height()*1.5
		color(coldic.font,showsegment*bar)
		draw_arrow_2lines(Vec2(first,harrow), Vec2(current, barBox[1]+barBox.height()-thicknessSize*4), thicknessSize*2,thicknessSize*6)
	
	dot(fontSize*0.2,first,hline)
	
#	color(black,showsegment*nomansland*0.7*bar)
	box_image(res["petit"],ims["rature"],showsegment*nomansland*bar)
#	rectangle(res["petit"])
	
	color(coldic.font,clamp((nomansland-0.5)*2)*bar)
	text(res["petit"][0], res["petit"][1]+res["petit"].height()*1.3, "Pas de sur-chantillonnage",timefont,size=fontSize)
	
	fracbox=canva.inset(0.35).restrict_aspect(1.0).move_up(0.1)
	if showfrac>epsilon:
		if adaptatif>epsilon:
			r=rot.get()
			mode=2
			if continu:
				mode=3
			draw_fractal_main(fracbox.inset(0.2), thicknessSize*2, mode, count*segment, 1.3, r*0.3, showfrac*adaptatif)
		if adaptatif<0.99:
			draw_fractal_main(fracbox.inset(0.2), thicknessSize*2, 0, count*segment, -1, 0, showfrac*(1-adaptatif))
	
	
	
	precision=1
	
	fonction_box=canva.inset(0.45).move_left(3.5). move_down(1.0).restrict_aspect(3)
	color(black,clamp(snow_f))
	thickness(thicknessSize*0.4)
	snowFonc(fonction_box.move_up(3),0)
	snowFonc(fonction_box,1)
	color(purple,clamp(snow_f))
	draw_arrow(fonction_box[0]+fonction_box.width()*0.5, fonction_box[1]+fonction_box.height()*2.5, fonction_box[0]+fonction_box.width()*0.5, fonction_box[1]+fonction_box.height()*1.5,thicknessSize,thicknessSize*3)
	
	a=clamp(snow_f*2)
	textC=red.interp(black, clamp(snow_f))
	color(textC,a)
	text(fonction_box[0]-fonction_box.width()*0.1, fonction_box[1]-fonction_box.height()*0.4, "Prcision variable", timefont, size=fontSize, anchor='tw')
#	text(fonction_box[0]+fonction_box.width()*0.8, fonction_box[1]+fonction_box.height()*1.5, " 1 -> 4", timefont, size=fontSize, anchor='tw')
	
	a=clamp((snow_f-1)*2)
	textC=red.interp(black, clamp(snow_f-1))
	color(textC,a)
	text(fonction_box[0]-fonction_box.width()*0.1, fonction_box[1]-fonction_box.height()*0.4-fontSize, "Adaptative", timefont, size=fontSize, anchor='tw')
	
	a=clamp((snow_f-2)*2)
	textC=red.interp(black, clamp(snow_f-2))
	color(textC,a)
	text(fonction_box[0]-fonction_box.width()*0.1, fonction_box[1]-fonction_box.height()*0.4-2*fontSize, "Continue", timefont, size=fontSize, anchor='tw')
	
	
	thickness(thicknessSize*0.4)
	graphBox=canva.restrict_aspect(0.5).inset(0.2).move_right(1.3). move_down(0.2)
	if tree>epsilon:
		color(black,clamp(tree))
		text(graphBox[0]+graphBox.width()*0.5,graphBox[1]+graphBox.height()*1.1, "Reprsente par un\narbre dynamique", timefont, justify=0.5, anchor='cc', size=fontSize)
		thickness(thicknessSize)
		draw_graph_main(1, graphBox, 5, thicknessSize*4, 1, 3.14*graphRot, clamp(tree))
	
	
def uturnCanva(b):
	return b.inset(0.45).move_left(3.0).move_up(2.0)

def dgDecomposition(
		processus=(SCALAR,0,1.0,0.0),
		fra=(SCALAR,0,1.0,0.0),
		modelisation=(SCALAR,0,1.0,0.0),
		noslide=(BOOLEAN,False),
		showRec=(SCALAR,0,1.0,0.0),
		avan=(SCALAR,0,1.0,0.0),
		evaluation1=(SCALAR,0,1.0,0.0),
		zone=(SCALAR,0,3.0,0.0)
	):
	wa=window_aspect()
	canva=get_cams("part2")

	bigBox=canva.inset(0.15).move_down(0.1)
	frameArray=[
		bigBox.bottom(0.4).left(0.4),
		bigBox.top(0.4).left(0.4)
	]
	
	cams["dg_modelisation"]=frameArray[0]
	cams["dg_evaluation"]=frameArray[1]
	
	if modelisation>epsilon:
		cams["current"]=canva.interp(frameArray[0],modelisation)
	elif evaluation1>epsilon:
		cams["current"]=canva.interp(frameArray[1],evaluation1)
	else:
		cams["current"]=canva
	
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	color(coldic.font,1)
	set_camera(cams["current"])
	title(canva,"Modlisation et gnration")
	
	creationBox=bigBox.inset(0.43).move_right(2.7).move_up(0.6)
	res=draw_processus(creationBox,thicknessSize*2,1,processus,True)
	
	p1=Vec2(res["center"].x-res["rayon"], res["center"].y)
	

	grey=Color(0.7,0.7,0.7,fra)
	color(grey)
	Vec2.line(p1,Vec2(bigBox[0],p1.y))
	
	# ZONE1
	color(coldic.font,fra*clamp(zone))
	ptext=Vec2(frameArray[0][0]+frameArray[0].width(), frameArray[0][1]+frameArray[0].height()*0.2)
	text(ptext.x,ptext.y, "Modlisation", timefont, size=fontSize,anchor='cw')
	
	tmpBox=frameArray[0].inset(0.2)
	if not noslide:
		tmpBox=tmpBox.interp(uturnCanva(frameArray[0]),clamp(modelisation))
	draw_snowNode(tmpBox,wfunc(get_cams("current")),avan,fra*clamp(zone))

	# ZONE2
	color(coldic.font,fra*clamp(zone-1))
	ptext=Vec2(frameArray[1][0]+frameArray[1].width(), frameArray[1][1]+frameArray[1].height()*1.1)
	text(ptext.x,ptext.y, "Gnration", timefont, size=fontSize,anchor='tw')
	res1=text(ptext.x+2*fontSize, ptext.y-1*fontSize, "- Arbre dynamique", timefont, size=fontSize,anchor='tw')
	text(ptext.x+2*fontSize, ptext.y-2*fontSize, "- Critres d'arrt", timefont, size=fontSize,anchor='tw')
	
	if showRec>epsilon:
		tmpBox=Rect(res1["left"]-fontSize*0.2, res1["bottom"], res1["right"]+fontSize*0.2, res1["top"])
		tmpBox=tmpBox.interp(tmpBox.move_down(1),clamp(showRec-1))
		color(red,clamp(showRec)*0.3)
		rectangle(tmpBox)
		
	
	color(res["color"][1],fra*clamp(zone-1))
	thickness(thicknessSize*0.4)
	graphBox=frameArray[1].restrict_aspect(0.5)
#	graphColor["normal"]=coldic.inst
#	graphColor["leave"]=coldic.precision
	thickness(thicknessSize*1.3)
	draw_graph_main(1, graphBox, 3, thicknessSize*4, 1, 3.14*0.5, fra*clamp(zone-1))
	
	

def circle_and_text(box,txt,s,w,ut,alpha,c=coldic.classe):
	thickness(w)
	p=get_middle(box)
	r=box.restrict_aspect(1).height()*0.5
	color(c,alpha)
	circle(r,p.x,p.y)
	color(black,alpha)
	if ut:
		uturn.draw(p,r,w)
	text(p.x,p.y,txt,timefont,anchor="cc",size=s)

def circles_arrow(box,box2,w):
	p1=get_middle(box)
	r=box.restrict_aspect(1).height()*0.5
	p2=get_middle(box2)-p1
	n=p2.norm()
	p2=p2*(1.0/n)
	
	draw_arrow(p1.x+p2.x*r,p1.y+p2.y*r, p1.x+p2.x*(n-r-4*w), p1.y+p2.y*(n-r-4*w),w,4*w)



def draw_classe(classBox,classe,aaa):
	fs=classBox.height()/16.0
	tab=2*fs
	start=Vec2(classBox[0]+fs*1,classBox[1]+classBox.height()-fs*0.5)
	dec=Vec2(0,-fs*1.1)
	commentColor=Color(0.4,0.4,0.4)
	keywordColor=Color(0.57,0.38,0.14)
	alpha=clamp(classe)*aaa
	
	xcoord=0
	color(coldic.classe,alpha)
	frame(classBox)
	p=start+dec*xcoord
	color(commentColor,alpha)
	text(p.x,p.y,"// dfinition de \"flocon de neige\"", timefont,size=fs,anchor="tw")
	color(coldic.font,alpha)
	xcoord+=1
	p=start+dec*xcoord
	text(p.x,p.y,"class flocon : dgBaseClass",timefont,size=fs,anchor="tw")
	xcoord+=1
	p=start+dec*xcoord
	color(keywordColor,alpha)
	text(p.x,p.y,"{",timefont,size=fs,anchor="tw")

	xcoord+=1
	alpha=clamp(classe-1)*aaa
	color(commentColor,alpha)
	p=start+dec*xcoord
	text(p.x+tab,p.y,"// constructeur", timefont,size=fs,anchor="tw")
	xcoord+=1
	color(coldic.font,alpha)
	p=start+dec*xcoord
	text(p.x+tab,p.y,"flocon(...)", timefont,size=fs,anchor="tw")
#	xcoord+=1
#	color(coldic.font,alpha)
#	p=start+dec*xcoord
#	text(p.x+tab,p.y,"~flocon(...)", timefont,size=fs,anchor="tw")
	
	xcoord+=1.5
	alpha=clamp(classe-2)*aaa
	p=start+dec*xcoord
	color(commentColor,alpha)
	text(p.x+tab,p.y,"// fonctions OpenGL", timefont,size=fs,anchor="tw")
	xcoord+=1
	p=start+dec*xcoord
	text(p.x+tab,p.y,[Color(keywordColor,alpha), "virtual",Color(coldic.font,alpha), " afficheForme(...)"], timefont,size=fs,anchor="tw")
	xcoord+=1
	p=start+dec*xcoord
	text(p.x+tab,p.y,[Color(keywordColor,alpha), "virtual",Color(coldic.font,alpha), " afficheBoteEnglobante(...)"], timefont,size=fs,anchor="tw")
	
	alpha=clamp(classe-3)*aaa
	xcoord+=1.5
	color(commentColor,alpha)
	p=start+dec*xcoord
	text(p.x+tab,p.y,"// gnration des fils", timefont,size=fs,anchor="tw")
	xcoord+=1
	color(coldic.font,alpha)
	p=start+dec*xcoord
	text(p.x+tab,p.y,[Color(keywordColor,alpha), "virtual",Color(coldic.font,alpha), " gnreFils(...)"], timefont,size=fs,anchor="tw")
	
	xcoord+=1
	p=start+dec*xcoord
	color(keywordColor,alpha)
	text(p.x,p.y,"}",timefont,size=fs,anchor="tw")
	
	
def draw_terre(tmpBox,w,alpha):
	dec=1.3
	fontSize=tmpBox.width()*0.3
	color(coldic.classe,alpha)
	box1=tmpBox.restrict_aspect(1.0)
	circle_and_text(box1,"terre",fontSize,w,False,alpha)
	box2=box1.move_down(dec).move_right(1.0)
	circle_and_text(box2,"prairie",fontSize*0.9,w,False,alpha)
	box3=box2.move_left(2.0)
	circle_and_text(box3,"ocan",fontSize*0.9,w,False,alpha)
	box4=box3.move_down(dec).move_right(2.0)
	circle_and_text(box4,"2D",fontSize,w,False,alpha)
	box5=box4.move_left(2.0)
	circle_and_text(box5,"poisson",fontSize*0.8,w,False,alpha)
	box6=box5.move_down(dec).move_right(2.0)
	circle_and_text(box6,"2.5D",fontSize,w,False,alpha)
	box7=box6.move_down(dec)
	circle_and_text(box7,"3D",fontSize,w,False,alpha)
	circles_arrow(box1,box2,w)
	circles_arrow(box1,box3,w)
	circles_arrow(box2,box4,w)
	circles_arrow(box3,box5,w)
	circles_arrow(box4,box6,w)
	circles_arrow(box6,box7,w)
	
	boxArray=[box1,box2,box3,box4,box5,box6,box7]
	return boxArray

def dgModelisation(
		build=(SCALAR,0,1.0,0.0),
		showsnow=(SCALAR,0,1.0,0.0),
		classe=(SCALAR,0,1.0,0.0),
		slideclasse=(SCALAR,0,1.0,0.0),
		show1=(SCALAR,1.0,1.0,0.0),
		show2=(SCALAR,1.0,1.0,0.0),
		nedit=(SCALAR,0,1.0,0.0),
		visu=(SCALAR,0,1.0,0.0),
		visutext=(SCALAR,0,1.0,0.0),
		pointinter=(SCALAR,0,1.0,0.0),
		inter=(SCALAR,0,2.0,0.0),
		tt=(SCALAR,0,2.0,0.0),
		tt2=(SCALAR,0,2.0,0.0),
		tt3=(SCALAR,0,2.0,0.0),
		uti=(SCALAR,0,2.0,0.0),
		slide=(SCALAR,0,1.0,0.0),
		showGui=(SCALAR,0,1.0,0.0),
		showGui2=(SCALAR,0,1.0,0.0),
		quoi=(SCALAR,0,1.0,0.0),
		showtext=(SCALAR,0,4.0,0.0),
		other=(SCALAR,0,2.0,0.0)
	):
	wa=window_aspect()
	canva=get_cams("dg_modelisation")
	set_camera(get_cams("dg_modelisation"))
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	
	if showGui>epsilon:
		color(black,showGui)
		box=canva.inset(0.1).move_down(0.1)
		box=box.restrict_aspect( xfig_gui.base.aspect())
		xfig_gui.set(box)
		for i in xfig_gui.listBox:
			tmpBox=xfig_gui.get(i)
			p=getRelPos(tmpBox,0.5,0)
			text(p.x, p.y+fontSize*0.1, txt_gui[i], timefont, size=fontSize, anchor='bc')
			box_image(tmpBox,ims[i],showGui)

	if showGui2>epsilon:
		box=canva.inset(0.1).move_down(0.1). restrict_aspect(ims["select3.jpg"].aspect)
		p=getRelPos(box,0.5,1)
		color(black,showGui2)
		text(p.x, p.y+fontSize*0.2, "Slection et dbogage", timefont, size=fontSize, anchor='bc')
		box_image(box,ims["select3.jpg"],showGui2)

	
	add=""
	c=Color(purple,1).interp(coldic.font,clamp(max(tt,tt2,tt3)-1))
	if tt>epsilon:
		txt=" : interface textuelle"
		m=min(int(clamp(tt)*len(txt)),len(txt))
		add=txt[0:m]
	elif tt2>epsilon:
		txt=" : environnement"
		m=min(int(clamp(tt2)*len(txt)),len(txt))
		add=txt[0:m]
	title(canva,[ Color(coldic.font,1),"Modlisation ", c, add],build)
	
	tmpBox=uturnCanva(canva)
	if showsnow>epsilon:
		draw_snowNode(tmpBox,wfunc(canva),1,showsnow)
		color(coldic.font,showsnow)
		text(tmpBox[0]+tmpBox.width()*0.5, tmpBox[1]+tmpBox.height()+fontSize*0.5, "Flocon :", timefont, size=fontSize, anchor='cc')


	
	if other>epsilon or inter>epsilon or pointinter>epsilon:
		tmpBox=tmpBox.outset(0.2).move_up(1.0)
		color(coldic.font,other)
		res=draw_terre(tmpBox,thicknessSize,other)
		
		box=tmpBox.move_right(3.5).move_down(1)
		circle_and_text(box,"?",fontSize*2,thicknessSize,False, clamp(pointinter))

		color(coldic.classe,clamp(quoi))
		txt1="""- d'afficher une forme
sur un intervalle de prcision
"""
		txt2="""- d'engendrer d'autres fonctions
si la prcision n'est pas suffisant
"""
		
		color(coldic.font,clamp(quoi))
		box=box.move_down(0.5).move_left(1.2)
		text(box[0],box[1],"Fonctions capable de :",timefont,size=fontSize,anchor='tw')
		text(box[0],box[1]-1.5*fontSize, txt1, timefont, size=fontSize, anchor='tw')
		
		color(coldic.font,clamp(quoi-1))
		text(box[0],box[1]-4*fontSize, txt2,timefont, size=fontSize, anchor='tw')

		color(purple,clamp(inter))
		box3=res[3]
		draw_yinterval(box3[1],box3[1]+box3.height(), box3[0]+box3.width()*1.3)
		color(purple,clamp(inter-1))
		box5=res[5]
		draw_yinterval(box5[1],box5[1]+box3.height(), box5[0]+box5.width()*1.3)
	
	classBox=canva.inset(0.1).move_down(0.1)
	fs=fontSize*0.8
	classBox2=classBox.inset(0.25).move_left(0.6)
	
	if classe>epsilon:
		tmpBox=classBox.interp(classBox2,slideclasse)
		color(0.9,0.9,0.9,clamp(classe)*show1)
		rectangle(tmpBox)
		draw_classe(tmpBox,classe,show1)
	
	w=classBox2.width()+thicknessSize
	h=w/ims["nedit"].aspect
	imbox=Rect(classBox2[0]-0.5*thicknessSize, classBox2[1]+classBox2.height()+0.5*thicknessSize,  classBox2[0]-0.5*thicknessSize+w, classBox2[1]+classBox2.height()+h+0.5*thicknessSize)
	box_image(imbox,ims["nedit"],nedit*show1)
	
	visuBox=classBox2.move_right(1.15).inset(0.1)
	if visu>epsilon:
		color(0.8,0.8,0.8,clamp(visu))
		rectangle(visuBox)
		color(coldic.inst,clamp(visu))
		frame(visuBox)
		color(black,clamp(visu))
		draw_fractal_main(visuBox.inset(0.36), thicknessSize*2, 2, 3, -1, 1,clamp(visu))
		w=visuBox.width()+thicknessSize
		h=w/ims["menubar"].aspect
		imbox=Rect(visuBox[0]-0.5*thicknessSize, visuBox[1]+visuBox.height()+0.5*thicknessSize,  visuBox[0]-0.5*thicknessSize+w, visuBox[1]+visuBox.height()+h+0.5*thicknessSize)
		box_image(imbox,ims["menubar"],clamp(visu))

		color(coldic.inst,clamp(visu))
		h=visuBox[1]+visuBox.height()*0.5
		draw_arrow(classBox2[0]+classBox2.width()+thicknessSize,h, visuBox[0]-thicknessSize*11, h, thicknessSize*6,thicknessSize*10)
	
	if showtext>epsilon:
		ccc=0.5
		pmSize=fontSize*0.7
		color(coldic.font,showtext*show2)
		hspace=0.3*fontSize
		w=visuBox[0]
		h=visuBox[1]+visuBox.height()+fontSize*2.5
		rr=text(w,h,"modlisation interactive\n(compilation  la vole)", timefont, size=fontSize, anchor="tw")
		pmbox=Rect(rr["left"]-ccc*fontSize,rr["bottom"]+fontSize*1, width=pmSize, height=pmSize)
		color(green,showtext*show2)
		draw_plus(pmbox,thicknessSize*2)
		
		h-=2*fontSize+hspace
		color(coldic.font,clamp(showtext-1)*show2)
		rr=text(w,h,"trs expressif", timefont, size=fontSize, anchor="tw")
		pmbox=Rect(rr["left"]-ccc*fontSize,rr["bottom"]+fontSize*0.7, width=pmSize, height=pmSize)
		color(green,clamp(showtext-1)*show2)
		draw_plus(pmbox,thicknessSize*2)

		h-=1*fontSize+hspace
		color(coldic.font,clamp(showtext-2)*show2)
		rr=text(w,h,"rapide", timefont, size=fontSize, anchor="tw")
		pmbox=Rect(rr["left"]-ccc*fontSize,rr["bottom"]+fontSize*0.7, width=pmSize, height=pmSize)
		color(green,clamp(showtext-2)*show2)
		draw_plus(pmbox,thicknessSize*2)

		h-=1*fontSize+hspace
		color(coldic.font,clamp(showtext-3)*show2)
		rr=text(w,h,"austre", timefont, size=fontSize, anchor="tw")
		pmbox=Rect(rr["left"]-ccc*fontSize,rr["bottom"]+fontSize*0.7, width=pmSize, height=pmSize)
		color(red,clamp(showtext-3)*show2)
		draw_minus(pmbox,thicknessSize*2)

	
	if uti>epsilon:
		color(coldic.font,clamp(uti))
		text(canva[0]+canva.width()*0.5,canva[1]+canva.height()*0.7,"Le crateur doit fournir :", timefont, size=fontSize, anchor="cc")

		box=canva.left(0.5).inset(0.2).move_down(0.15).move_right(0.8)
		color(coldic.classe,clamp(uti-1))
		p=Vec2(box[0],box[1]+box.height()*0.8)
		text(p.x,p.y,"Un ensemble\nde classes",timefont, size=fontSize, anchor='cc', justify=0.5)

		size=canva.height()*0.07
		terreBox=Rect(p.x,p.y-2*size, height=size, width=size )
		res=draw_terre(terreBox,thicknessSize,clamp(uti-1))

		color(coldic.inst,clamp(uti-2))
		p=Vec2(box[0]+box.width(),box[1]+box.height()*0.8)
		text(p.x,p.y,"Une instance\n\"axiome\"",timefont, size=fontSize, anchor='cc', justify=0.5)
		axiomBox=Rect(p.x,p.y-2*size, height=size, width=size )

		if uti>(3+epsilon):
			c=coldic.classe.interp(coldic.inst,clamp(uti-3))
			tmpBox=terreBox.interp(axiomBox,clamp(uti-3))
			circle_and_text(tmpBox,"terre",fontSize*0.5,thicknessSize,False,1,c)

			color(coldic.inst,clamp(uti-4))
			x=tmpBox[0]+tmpBox.width()*0.5
			y=tmpBox[1]-tmpBox.height()*0.5
			draw_arrow(x,y,x,y-tmpBox.height()*2,thicknessSize*3, thicknessSize*6)

def dgEvaluation(
		te=(SCALAR,0,1.0,0.0),
		ins=(SCALAR,0,1.0,0.0),
		showgraph=(SCALAR,0,1.0,0.0),
		crit=(SCALAR,0,1.0,0.0),
		graph=(SCALAR,0,1.0,0.0),
		voit=(SCALAR,0,1.0,0.0)
		
	):
	wa=window_aspect()
	canva=get_cams("dg_modelisation")
	set_camera(get_cams("dg_modelisation"))
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	
	title(canva,"Gnration de la scne 3D",1)
	
	mainbox=canva.inset(0.2).move_down(0.1)
	
	txt=[
		"- La scne est engendre  partir de l'axiome",
		"- En fonction de l'observation",
		"- Critres d'arrt : prcision et visibilit."
	]
	
	start=Vec2(mainbox[0]-mainbox.width()*0.1,mainbox[1]+mainbox.height())
	dec=Vec2(0,-fontSize*1.1)
	for i in range(0,min(int(te+1),len(txt))):
		alpha=te-i
		color(coldic.font,alpha)
		p=start+dec*i
		text(p.x,p.y,txt[i],timefont,size=fontSize,anchor="tw")
	
	
	if showgraph>epsilon:
#		graphColor["normal"]=coldic.inst
#		graphColor["leave"]=graphColor["normal"].interp(coldic.precision,crit)
		graphBox=scale_rect(mainbox.bottom(0.7),0.3,1).move_right(1.0). outset(0.1)
		res=draw_graph_main(1, graphBox, 4, thicknessSize*4, graph, 3.14*0.5, showgraph)
		color(black,pic(te,1,0.2))
		text(res["firstPoint"].x+fontSize,res["firstPoint"].y,"Axiome",timefont, size=fontSize,anchor='cw')
#		graphColor["leave"]=graphColor["normal"]
	
	if voit>epsilon:
		txt2="On ne calcule que\nce que l'on voit."
		txtBox=mainbox.left(0.5).restrict_aspect(len(txt2)/4)
		color(black,voit)
		res=text(canva[0]+canva.width()*0.2, canva[1]+canva.height()*0.4, txt2, timefont, size=fontSize,anchor="bw")
		color(red,voit*0.3)
		txt_frame(res)
	

#precisionPath=Path()
#precisionPath.moveto(0,1)
#precisionPath.curveto(1,1,1,1,1,0.5)
#precisionPath.curveto(1,0,1,0,2,0.0)
precisionPath=Path()
precisionPath.moveto(-2,1)
precisionPath.curveto(-1,1,-0.5,1,0,0.5)
precisionPath.curveto(0.5,0,1,0,2,0.0)
def draw_precision(box,w,x,fs,alpha):
	absis1=Vec2(box[0],box[1])
	absis2=Vec2(box[0]+box.width(),box[1])
	
	ordo1=Vec2(box[0]+box.width()*0.5,box[1])
	ordo2=Vec2(box[0]+box.width()*0.5,box[1]+box.height())
	h=box.height()*0.7
	
	color(black,alpha)
	draw_arrow(absis1.x,absis1.y,absis2.x,absis2.y,w,w*3)
	draw_arrow(ordo1.x,ordo1.y,ordo2.x,ordo2.y,w,w*3)
	
	color(coldic.comment,alpha*0.5)
	thickness(w)
	line(absis1.x,absis1.y+h,absis2.x,absis2.y+h)
	
	color(coldic.precision2,alpha)
	push()
	dec=x*box.width()*0.2
	size=box.width()/10
	translate(absis1.x+box.width()*0.5+dec,absis1.y)
	scale(size,box.height()*0.7)
	
	sw=w/box.width()
	widestroke(precisionPath,sw*5)
	pop()
	thickness(w)
	xcenter=box[0]+box.width()*0.5+dec
	line(box[0],box[1]+h,xcenter-size*2,box[1]+h)
	line(xcenter+size*2,box[1],box[0]+box.width(),box[1])
	
	color(black,alpha)
	text(box[0]+box.width()*0.7, box[1]-fs*0.3, "Prcision", timefont, size=fs, anchor='tw')
	text(box[0]+box.width()*0.5, box[1]+box.height()+fs*0.5, "Maturit", timefont, size=fs, anchor='bc')
	
	dic={}
	dic["middle"]=xcenter
	dic["size"]=size*2
	return dic

def dgPrecision(
		cohe=(INTEGER,0,3,0),
		drawmat=(SCALAR,0,1.0,0.0),
		sigx=(SCALAR,0,1.0,0.0),
		drawPrecision=(SCALAR,0,1.0,0.0),
		pre=(SCALAR,-1,1.0,0.0),
		oeil=(SCALAR,0,1.0,0.0),
		graph=(SCALAR,0,1.0,0.0),
		preTxt=(SCALAR,0,1.0,0.0),
		treshold=(SCALAR,0,1.0,0.0),
		txt1=(SCALAR,0,1.0,0.0),
		txt2=(SCALAR,0,1.0,0.0),
		slide=(SCALAR,0,1.0,0.0),
		fonc=(SCALAR,0,2.0,0.0)
	):
	wa=window_aspect()
	slideCoef=0.78
	canva=get_cams("dg_modelisation")
	canva=canva.interp(canva.move_up(slideCoef),slide)
	set_camera(get_cams("dg_modelisation"))
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	
	title(canva,"Prcision et transition",1)
	
	if preTxt>epsilon:
		yydec=fontSize*1.3
		p=getRelPos(canva,0.1,0.7)
		color(black,clamp(preTxt-0))
		text(p.x,p.y,"- Calcul de la prcision automatique",timefont,size=fontSize,anchor='tw')
		p.y-=yydec
		color(black,clamp(preTxt-1))
		text(p.x,p.y,"- Le crateur donne les botes englobantes",timefont,size=fontSize,anchor='tw')
		p.y-=yydec
		color(black,clamp(preTxt-2))
		text(p.x,p.y,"- Prcision rglable, redfinissable",timefont,size=fontSize,anchor='tw')
		p.y-=yydec
		color(black,clamp(preTxt-3))
		text(p.x,p.y,"- Matrise du compromis qualit/performance",timefont,size=fontSize,anchor='tw')

	if drawmat>epsilon:
		precisionBox=canva.inset(0.3).restrict_aspect(4.0).move_right(0.3)
		hh=precisionBox.height()
		res=draw_precision(precisionBox,thicknessSize,sigx,fontSize,drawmat)
		if drawPrecision>epsilon:
			color(coldic.precision,drawPrecision)
			x=res["middle"]+(pre-0.5)*res["size"]*2
			line(x, precisionBox[1], x, precisionBox[1]+hh)
		
		if treshold>epsilon:
			color(coldic.precision2,treshold)
			x=res["middle"]+(0-0.5)*res["size"]*2
			line(x, precisionBox[1]-0.1*hh, x, precisionBox[1]+hh)
			text(x, precisionBox[1]-0.2*hh, "Gnration\ndes noeuds fils", timefont, size=fontSize,anchor='tc')
	
	r1=canva.inset(0.45).move_left(2.5).move_up(2).restrict_aspect(1)
	thickness(thicknessSize)
	maincenter=get_middle(r1)
	mainrayon=r1.height()
	color(coldic.inst,clamp(fonc))
	circle(mainrayon,maincenter.x,maincenter.y)
	
	color(black,clamp(fonc))
	matur=clamp(1-pre)
	if cohe==1:
		matur=clamp((matur-0.2)/0.3)
		matur*=matur
	elif cohe==2:
		matur=1-clamp((0.8-matur)/0.3)
		matur*=matur
	elif cohe==3:
		if(matur>0.5):
			matur=1
		else:
			matur=0
	
	snowFonc(r1.restrict_aspect(2),matur)
	dist=4.0+pre*2.0
	box_image(r1.move_right(dist),ims["oeil2"],oeil)
	
	if clamp(fonc-1)>epsilon:
		color(black,clamp(fonc-1))
		
		r2=r1.move_down(2).inset(0.15)
		rayon=r2.height()*0.4
		p=get_middle(r2)
		for i in range(0,4):
			color(coldic.inst,clamp(fonc-1))
			x=p.x+r2.width()*(i-1.5)
			circle(rayon,x,p.y)
			v=Vec2(x,p.y)-maincenter
			n=v.norm()
			v=v*(1/n)
			color(black,clamp(fonc-1))
			draw_arrow(
				maincenter.x+mainrayon*v.x,
				maincenter.y+mainrayon*v.y,
				maincenter.x+(n-rayon-thicknessSize*3)*v.x,
				maincenter.y+(n-rayon-thicknessSize*3)*v.y,
				thicknessSize,
				thicknessSize*3)
	
	if graph>epsilon:
		graphBox=canva.left(0.6).inset(0.2)
		color(black,graph)
#		graphColor["normal"]=coldic.inst
#		graphColor["leave"]=coldic.precision
		cc=0.1
		draw_graph_main(1, graphBox, 2+6*clamp(1-pre), thicknessSize*4, 1, -3.14*0.5, graph)
	
	if txt1>epsilon:
		color(black,txt1)
		p=Vec2(canva[0]+canva.width()*0.2, canva[1]+canva.height()*0.4)
		tt=[ Color(black,clamp(txt1)), "Prcision :\n   - fonction de l'observation\n", Color(black,clamp(txt1-1)), "   - fonction du temps :\n    precision(t) = evolution( precision(", Color(red,clamp(txt1-1)), "t-dt", Color(black,clamp(txt1-1)), ") , observateur(t) )" ]
		text(p.x, p.y, tt, timefont, size=fontSize, anchor='tw')
	
	if txt2>epsilon:
		color(red,txt2)
		p=Vec2(r1[0], r1[1]-r1.height())
		text(p.x,p.y,"Mauvaise\nqualit transitoire",timefont,size=fontSize,anchor='cc')
	
	
	color(coldic.important,clamp(txt1-2))
	middle=get_middle(titleBox(canva.move_down(slideCoef)))
	text(middle.x,middle.y, "Mmoire", timefont, size=canva.height()*titleSize, justify=0.5)
	

def get_clockBox(canva):
	return canva.right(0.1).top(0.1).restrict_aspect(1.0).move_left(1.0). move_down(1.0)


def draw_anim(box,n,alpha=1):
	res=None
	box=box.restrict_aspect(ims["cubeanim"][0].aspect)
	if n>4:
		n=4
	if n>0:
		res=box_image(box,ims["cubeanim"][n-1],alpha)
	frame(box)
	return res





class Tampon:
	def __init__(self,nb):
		self.nb=nb
		self.graphTime=[-1,-1,-1,-1]
		self.angle=[-1,-1,-1,-1]
		self.i=0
		self.currentTime=-1
		self.mode=0
	def inc(self,t):
		if self.currentTime==t:
			return
		self.currentTime=t
		self.i+=1
		if self.i==self.nb:
			self.i=0
		self.graphTime[self.i]=t
		self.angle[self.i]=(1245*t)%6.28
	
	def draw(self,bigBox,comp,w,alpha):
		first_box=bigBox.right(1.0/self.nb)
		for jj in range(0,self.nb):
			j=self.i-jj
			if j<0:
				j+=self.nb
			if self.graphTime[j]!=-1:
				graphbox=first_box.move_left(jj)
				cc=1
				if jj==0:
					cc=comp
#				graphColor["normal"]=coldic.inst
#				graphColor["leave"]=coldic.precision
				draw_graph_main(1, graphbox, 5, w*3, cc, self.angle[j]-3.14, alpha)

tampon=Tampon(4)


def get_window_box(canva):
	dic={}
	dic["box"]=canva.inset(0.4).restrict_aspect(2).move_down(3)
	dic["h"]=dic["box"][1]+dic["box"].height()*0.5
	dic["p1"]=Vec2(dic["box"][0]-dic["box"].width()*1.5,dic["h"])
	dic["p2"]=Vec2(dic["box"][0]+dic["box"].width()*2.5,dic["h"])
	return dic

def dgMemoire(
		tv=(SCALAR,0,1000.0,0.0),
		dos=(SCALAR,0,2.0,0.0),
		build=(SCALAR,0,1.0,0.0),
		title=(SCALAR,0,1.0,0.0),
		showclock=(SCALAR,0,1.0,0.0),
		showcase=(SCALAR,0,1.0,0.0),
		showwindow=(SCALAR,0,1.0,0.0),
		modif=(SCALAR,0,2.0,0.0),
		modif1=(SCALAR,0,2.0,0.0),
		modif2=(SCALAR,0,2.0,0.0),
		oneGraph=(SCALAR,0,1.0,0.0),
		fleche=(SCALAR,0,1.0,0.0),
		tourHorloge=(SCALAR,0,1.0,0.0),
		txt_gen=(SCALAR,0,3.0,0.0),
		animcu=(SCALAR,0,1.0,0.0),
		memcase=(SCALAR,0,1.0,0.0),
		memoire=(SCALAR,0,5.0,0.0),
		linkto=(SCALAR,0,5.0,0.0),
		ide=(SCALAR,0,5.0,0.0),
		newide=(SCALAR,0,5.0,0.0),
		newlinkto=(SCALAR,0,5.0,0.0),
		death=(SCALAR,0,1.0,0.0),
		slide=(SCALAR,0,1.0,0.0),
		slide2=(SCALAR,0,1.0,0.0),
		approche=(SCALAR,0,1.0,0.0),
		slide3=(SCALAR,0,1.0,0.0),
		showanimcu=(SCALAR,0,1.0,0.0),
		tampontxt=(SCALAR,0,1.0,0.0),
		mode=(SCALAR,0,1.0,0.0),
		subTitle=(SCALAR,0,1.0,0.0),
		rot=(SCALAR,-1.0,1.0,-1.0),
		colorTitle=(SCALAR,0,1.0,0.0)
	):
	wa=window_aspect()
	canva=get_cams("dg_modelisation")
	windic=get_window_box(canva)

	ytimeline=windic["h"]
	x1timeline=windic["p1"].x
	x2timeline=windic["p2"].x

	h_bigBox=canva.height()*0.4
	nbElem=4
	bigBox = Rect(x1timeline, ytimeline+0.1*h_bigBox, x2timeline, ytimeline+1.1*h_bigBox)
	w_bigBox=bigBox.width()/nbElem
	first_box=bigBox.right(1.0/nbElem)
	root1=None
	root2=None

	memBox= scale_rect( first_box.top(0.3).move_left(0.5),1.8,1).outset(0.9).restrict_aspect(wa)
	
	set_camera(get_cams("dg_modelisation").interp(memBox,slide))
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	
	color(coldic.important.interp(black,colorTitle),title)
	middle=get_middle(titleBox(canva))
	text(middle.x,middle.y, "Gnration dynamique", timefont, size=canva.height()*titleSize, justify=0.5)
	
	clockBox=get_clockBox(canva)
	draw_clock(get_middle(clockBox),clockBox.height()*0.5,tv,showclock)
	
	if tourHorloge>epsilon:
		color(black,tourHorloge)
		p=get_middle(clockBox)
		text(p.x-2*fontSize,p.y-3*fontSize,"Un tour d'horloge\n=>nouvel affichage", timefont, size=fontSize, anchor='bc',justify=0.5)


	if build>epsilon:
		color(black,build)
		draw_arrow(x1timeline, ytimeline, x2timeline, ytimeline, thicknessSize, thicknessSize*3)
		text(x2timeline-fontSize*4, ytimeline-1.1*fontSize, "Temps", timefont, size=fontSize)
		
	if showwindow>epsilon:
		tmpBox=bigBox.interp(windic["box"],slide3)
		color(coldic.memoire,clamp(showwindow)*0.5)
		rectangle(tmpBox)
		color(coldic.memoire,clamp(showwindow))
		frame(tmpBox)
	
	if approche>epsilon:
		ppp=Vec2(canva[0]+canva.width()*0.15, canva[1]+canva.height()*0.73)
		txt="Comment assurer la cohrence temporelle ?"
		text(ppp.x,ppp.y,txt, timefont,size=fontSize, anchor='tw' )
	
	if showcase>epsilon:
		color(coldic.comment,clamp(showcase-1))
		for i in range(1,nbElem):
			frame(first_box.move_left(i))
		
		color(purple,clamp(showcase))
		frame(first_box)
	
	graphbox=first_box.interp(first_box.move_left(1),clamp(dos))
	if oneGraph>epsilon:
#		graphColor["normal"]=coldic.inst
#		graphColor["leave"]=coldic.precision
		root1=draw_graph_main(1, graphbox, 5, thicknessSize*4, oneGraph*0.4, 3.14*rot, 1)
		if dos>1+epsilon:
			root2=draw_graph_main(1, first_box, 5, thicknessSize*4, clamp(dos-1)*0.4, -3.14, 1)
#		color(black, showanimcu)
#		animBox=graphbox.restrict_aspect(1.0).move_left(2.0).outset(0.4)
#		tmpBox=draw_anim(animBox, int(5*animcu), showanimcu)
		
		if modif>epsilon:
			txtArray=[
			"Mise  jour, 2 mthodes : ",
			"modification",
			"rgnration"]
			txtArray2=[
			["- Bien si forte cohrence temporelle","- Parcours d'arbre partiel"],
			["- Similaire  un parcours complet","- Re-calcul \" la vole\""]
			]
			
			firstStr=[Color(black,clamp(modif-0)), txtArray[0], Color(red,clamp(modif-0)), txtArray[1][0:int(len(txtArray[1])*clamp(modif1))], Color(green,clamp(modif-0)), txtArray[2][0:int(len(txtArray[2])*clamp(modif2))]]
			modifp=Vec2(canva[0]+canva.width()*0.15, canva[1]+canva.height()*0.73)
			
			text(modifp.x,modifp.y,firstStr, timefont,size=fontSize, anchor='tw')
			modifp.x+=fontSize

			modifp.y-=fontSize
			color(black,clamp(modif1-1))
			text(modifp.x,modifp.y,txtArray2[0][0], timefont,size=fontSize, anchor='tw')
			color(black,clamp(modif2-1))
			text(modifp.x,modifp.y,txtArray2[1][0], timefont,size=fontSize, anchor='tw')
			
			
			modifp.y-=fontSize
			color(black,clamp(modif1-2))
			text(modifp.x,modifp.y,txtArray2[0][1], timefont,size=fontSize, anchor='tw')
			color(black,clamp(modif2-2))
			text(modifp.x,modifp.y,txtArray2[1][1], timefont,size=fontSize, anchor='tw')
	
	
	if txt_gen>epsilon:
		txtArray=[
			"- A chaque nouvelle observation, la scne change",
			"- Arbre \"dynamique\" : rgnration",
			"- Comment garder une mmoire du pass ?"]
		p=Vec2(canva[0]+canva.width()*0.15, canva[1]+canva.height()*0.73)
		color(coldic.font,clamp(txt_gen-0))
		text(p.x, p.y-fontSize*1.1*0, txtArray[0] ,timefont ,size=fontSize ,anchor='tw')
		color(coldic.font,clamp(txt_gen-1))
		text(p.x, p.y-fontSize*1.1*1, txtArray[1] ,timefont ,size=fontSize ,anchor='tw')
		color(coldic.font,clamp(txt_gen-2))
		text(p.x, p.y-fontSize*1.1*2, txtArray[2] ,timefont ,size=fontSize ,anchor='tw')
		
	
	if fleche>epsilon:
		color(coldic.memoire, fleche*(1-slide))
		hh=first_box[1]+first_box.height()*0.7
		draw_arrow(
			first_box[0]+first_box.width()*0.3, hh,
			first_box[0]-first_box.width()*0.3, hh,
			thicknessSize*3,thicknessSize*9)
		text(first_box[0]+first_box.width(),
			first_box[1]+first_box.height()*1.2, "Connaissance de l'tat prcdent", timefont, size=fontSize, anchor='te')
	
	if memcase>epsilon:
		color(coldic.comment,clamp(memcase)*(1-slide))
		frame(memBox)
	
	
	
	
	if tampontxt>epsilon:
		color(coldic.font,tampontxt)
		text(canva[0]+canva.width()*0.5, canva[1]+canva.height()*0.7, "Tampon d'arbres", timefont, size=fontSize, anchor='cc')
		color(red,tampontxt*0.5)
		rectangle(bigBox.left(1.0/(nbElem)))
	
	if mode>epsilon:
		deathBox=bigBox.left(1.0/nbElem)
		if tampon.mode!=1:
			tampon.__init__(nbElem-1)
			tampon.mode=1
		tvi=int(tv)
		comp=tv-tvi
		tampon.inc(tvi)
		bigBox2=bigBox.right(float(nbElem-1)/nbElem)
		tmpBox=bigBox2.interp(bigBox2.move_left(1.0/(nbElem-1)),slide2)
		tampon.draw(tmpBox, comp,thicknessSize,mode)
		
		if death>epsilon:
			color(red,clamp(death))
			draw_cross(deathBox.inset(0.2),thicknessSize*4)
			color(red,clamp(death-1))
			text(deathBox[0],deathBox[1]+deathBox.height()*1.2, "Destruction", timefont, size=fontSize, anchor='tw')


class Segment:
	def __init__(self,nb):
		self.arrayVec2=[]
		self.current=0
		for i in range(0,nb):
			self.arrayVec2.append(Vec2(0,0))
	def push(self,t1,t2):
		self.current+=1
		self.arrayVec2[self.current-1]=Vec2(t1,t2)
	def isOk(self,t):
		m=min(self.current,len(self.arrayVec2))
		for i in range(0,m):
			if t>self.arrayVec2[i].x and t<self.arrayVec2[i].y:
				return False
		return True

seg=Segment(10)

def bilanArbre(
		ti=(SCALAR,0,1.0,0.0),
		showtooo=(SCALAR,0,1.0,0.0),
		tooo=(SCALAR,0,1.0,0.0)
	):
	wa=window_aspect()
	slideCoef=0.78
	canva=get_cams("dg_modelisation")
	set_camera(get_cams("dg_modelisation"))
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)

	color(coldic.font,ti)
	middle=get_middle(titleBox(canva))
	text(middle.x,middle.y, "Arbre dynamique : bilan", timefont, size=canva.height()*titleSize, justify=0.5)
	
	if showtooo>epsilon:
		pppp=getRelPos(canva,0.1,0.77)
		ydec=fontSize*1.5
		color(coldic.font,clamp(tooo-0)*showtooo)
		text(pppp.x, pppp.y, "- Arbres dynamiques : rgnration et mmoire", timefont, size=fontSize, anchor="tw")
		
		color(coldic.font,clamp(tooo-1)*showtooo)
		pppp.y-=ydec
		text(pppp.x, pppp.y, "- Adapte aux scnes animes", timefont, size=fontSize, anchor="tw")
		
		color(coldic.font,clamp(tooo-2)*showtooo)
		pppp.y-=ydec
		text(pppp.x, pppp.y, "- Par dfaut, tout est recalcul", timefont, size=fontSize, anchor="tw")
		
		color(coldic.font,clamp(tooo-3)*showtooo)
		pppp.y-=ydec
		text(pppp.x, pppp.y, "- Mcanismes additionnels plus persistants", timefont, size=fontSize, anchor="tw")


def dgAnimation(
		build=(SCALAR,0,1.0,0.0),
		title=(SCALAR,0,2.0,0.0),
		showclock=(SCALAR,0,1.0,0.0),
		txt=(SCALAR,0,4.0,0.0),
		slide=(SCALAR,0,1.0,0.0),
		showstep=(SCALAR,0,1.0,0.0),
		life=(SCALAR,0,1.0,0.0),
		showwindow=(SCALAR,0,1.0,0.0),
		showtooo=(SCALAR,0,1.0,0.0),
		tooo=(SCALAR,0,1.0,0.0),
		arbrePerm=(SCALAR,0,1.0,0.0),
		animeq=(SCALAR,0,2.0,0.0),
		segment=(INTEGER,0,1.0,0.0),
		drawnode=(SCALAR,0,1.0,0.0),
		txtwindow=(SCALAR,0,1.0,0.0),
		tv=(SCALAR,0,1000.0,0.0)
	):
	wa=window_aspect()
	slideCoef=0.78
	canva=get_cams("dg_modelisation")
	set_camera(get_cams("dg_modelisation"))
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	
	if title>epsilon:
		color(coldic.font,title)
		middle=get_middle(titleBox(canva))
		text(middle.x,middle.y, "Mmoire et animation", timefont, size=canva.height()*titleSize, justify=0.5)
	
	windic=get_window_box(canva)
	
	if showwindow>epsilon:
		color(black,showwindow)
		Vec2.arrow(windic["p1"], windic["p2"], thicknessSize)
		text(windic["p2"].x-fontSize*4, windic["p2"].y-1.1*fontSize, "Temps", timefont, size=fontSize)
		
		color(coldic.memoire,clamp(showwindow)*0.5)
		rectangle(windic["box"])
		color(coldic.memoire,clamp(showwindow))
		frame(windic["box"])
		p1=Vec2(windic["box"][0]+windic["box"].width(),windic["h"])
		dec=Vec2(fontSize,fontSize)
		thickness(thicknessSize)
		
		color(coldic.important,clamp(txtwindow-1))
		Vec2.line(p1+dec*1.5,p1)
		dot(thicknessSize*3,p1.x,p1.y)
		pp=p1+dec*2
		text(pp.x,pp.y,"prsent",timefont,size=fontSize,anchor='tw')
		
		if txtwindow>epsilon:
			pp=windic["p1"]*0.5+windic["p2"]*0.5
			hdec=windic["box"].height()*0.5+fontSize
			color(coldic.memoire,clamp(txtwindow))
			text(pp.x,pp.y-hdec,"\"Fentre temporelle\"", timefont, size=fontSize, anchor='tc')
			
	
	if showclock>epsilon:
		clockBox=get_clockBox(canva)
		draw_clock(get_middle(clockBox),clockBox.height()*0.5,tv,showclock)
	
	lastx=None
	if showstep>epsilon:
		tvi=int(tv)
		pulse=tv-tvi
		dec=(windic["p2"].x-windic["p1"].x)/15
		hcut=fontSize*0.5
		trigh=dec*0.4
		
		if arbrePerm>epsilon:
			color(green,arbrePerm)
			yydec=6*trigh
			x=windic["box"][0]+windic["box"].width()-trigh
			polygon(x-trigh, windic["h"]+hcut*0.2-trigh*2+yydec, x+trigh, windic["h"]+hcut*0.2-trigh*2+yydec, x, windic["h"]+hcut*0.2+trigh*2+yydec)
		
		x=windic["p1"].x+dec*(1-pulse)
		presentx=windic["box"][0]+windic["box"].width()
		firstSeg=Vec2(presentx+1,presentx+1)
		while x<windic["p2"].x:
			color(black,showstep)
			line(x,windic["h"]-hcut,x,windic["h"]+hcut)
			if x<presentx:
				co=purple.interp(coldic.comment, 1-clamp((x-(windic["box"][0]-dec))/dec))
				color(co,clamp(showstep)*0.8*(1-drawnode))
				polygon(x-trigh, windic["h"]+hcut*0.2-trigh*2, x+trigh, windic["h"]+hcut*0.2-trigh*2, x, windic["h"]+hcut*0.2+trigh*2)
				
				if drawnode>epsilon:
					t=tv-(presentx-x)/dec
					if seg.isOk(t):
						color(co,clamp(showstep)*(drawnode))
						dot(trigh*0.5, x, windic["h"])
						if firstSeg.x>presentx:
							firstSeg.x=x
					else:
						if firstSeg.x<presentx and firstSeg.y>presentx:
							firstSeg.y=x
				else:
					seg.__init__(10)
			else:
				if lastx==None:
					lastx=x-dec
			x=x+dec
		
		if life>epsilon:
			color(coldic.font,clamp(life))
			line(firstSeg.x, windic["h"]+fontSize, firstSeg.y-dec, windic["h"]+fontSize)
			line(firstSeg.x, windic["h"]+fontSize*1.3, firstSeg.x, windic["h"]+fontSize*0.7)
			line(firstSeg.y-dec, windic["h"]+fontSize*1.3, firstSeg.y-dec, windic["h"]+fontSize*0.7)
			
			color(coldic.font,clamp(life-1))
			text(firstSeg.x, windic["h"]+fontSize*2.2, "Naissance", timefont, size=fontSize)
			text(firstSeg.y-dec, windic["h"]+fontSize*2.2, "Mort", timefont, size=fontSize)
		
		
	
	if txt>epsilon:
		start=getRelPos(canva,0.1,0.77)
		color(coldic.font,clamp(txt))
		text(start.x, start.y, "La connaissance des pas de temps prcdents permet", timefont, size=fontSize, anchor="tw")
		
		start.y-=fontSize*1.3
		start.x+=fontSize*3
		color(coldic.font,clamp(txt-1))
		text(start.x, start.y, "- Interpolation durant une transition ", timefont, size=fontSize, anchor="tw")

		color(coldic.font,clamp(txt-2))
		start.y-=fontSize*1.3
		text(start.x, start.y, "- Optimisation par cohrence temporelle", timefont, size=fontSize, anchor="tw")

		color(coldic.font,clamp(txt-3))
		start.y-=fontSize*1.3
		text(start.x, start.y, "- Animation \"ractive\"", timefont, size=fontSize, anchor="tw")

		start.y-=fontSize*1
		c1=Color(coldic.font,clamp(animeq))
		c2=Color(coldic.memoire,clamp(animeq))
		resArrow=text(start.x+3*fontSize, start.y, [ c1,"a(",c2,"t",c1,").dt  = p(",c2,"t-2.dt", c1,")-2.p(", c2,"t-dt",c1,")+p(", c2,"t", c1,")"], timefont, size=fontSize, anchor="tw")
		text(start.x+3*fontSize+2.55*fontSize, start.y-fontSize*0.4, [c1,"2"], timefont, size=fontSize*0.7, anchor="bw")
		start.y+=fontSize*1
		

		
		start.y-=fontSize*1.3
		start.x-=fontSize*3
		color(coldic.font,clamp(txt-4))
		text(start.x, start.y, "D'autres types de \"mmoire\"", timefont, size=fontSize, anchor="tw")
		
		start.y-=fontSize*1.3
		start.x+=fontSize*3
		color(coldic.font,clamp(txt-5))
		text(start.x, start.y, "- Naissance et mort de chaque noeud", timefont, size=fontSize, anchor="tw")
	
		start.y-=fontSize*1.3
		color(coldic.font,clamp(txt-6))
		text(start.x, start.y, "- Arbre permanent", timefont, size=fontSize, anchor="tw")
		
		presentx=windic["box"][0]+windic["box"].width()
		color(coldic.memoire,clamp(animeq-1))
		ha=resArrow["bottom"]
		hb=windic["h"]+fontSize
		taba=[resArrow["left"]+resArrow["width"]*0.4, resArrow["left"]+resArrow["width"]*0.75, resArrow["left"]+resArrow["width"]*0.95]
		tabb=[lastx-dec*2, lastx-dec*1, lastx-dec*0]
		for i in range(0,3):
			line(taba[i],ha,tabb[i],hb)
			dot(fontSize*0.2,tabb[i],hb)
		start.y+=fontSize*1
		
		
	if segment>0:
		if seg.current<segment:
			seg.push(tv,tv+2)




def draw_gpu(box,w,alpha):
	box=box.restrict_aspect(3.0)
	color(black,alpha)
	p=get_middle(box)
	s=box.height()*0.8
	text(p.x, p.y, "GPU", timefont, size=s, anchor="cc")
	thickness(w)
	draw_imply(box,w)

def draw_gpu_and_screen(box,w,alpha):
	sf=box.height()*0.5
	dic={}
	dic["gpu"]=box.restrict_aspect(3.0)
	draw_gpu(dic["gpu"],w,alpha)
	dic["ecran"]=dic["gpu"].move_right(1.3).restrict_aspect(1.0).outset(0.9)
	color(coldic.comment,alpha)
	thickness(w*0.5)
	Ecran(dic["ecran"],w,1)
	color(orange,alpha)
	thickness(w)
	frame(dic["ecran"])
	color(black,alpha)
	p=get_middle(dic["ecran"])
	text(p.x, p.y, "Ecran", timefont, size=sf, anchor="cc")
	return dic




def dgRendu(
		build=(SCALAR,0,1.0,0.0),
		titletxt=(SCALAR,0,1.0,0.0),
		oneGraph=(SCALAR,0,1.0,0.0),
		showanimcu=(SCALAR,0,1.0,0.0),
		txt=(SCALAR,0,3.0,0.0),
		echa=(SCALAR,0,4.0,0.0),
		echa2=(SCALAR,0,4.0,0.0),
		gpu=(SCALAR,0,1.0,0.0),
		animcu=(SCALAR,0,4.0,0.0)
	):
	wa=window_aspect()
	slideCoef=0.78
	canva=get_cams("dg_modelisation")
	set_camera(get_cams("dg_modelisation"))
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	
	title(canva,"Visibilit et Affichage",titletxt)

	graphbox=canva.left(0.5).inset(0.3).move_left(0.2).move_down(0.3)
	if oneGraph>epsilon:
#		graphColor["normal"]=coldic.inst
#		graphColor["leave"]=coldic.precision
		root1=draw_graph_main(1, graphbox, 5, thicknessSize*4, oneGraph, 3.14, 1)
		color(black, showanimcu)
		animBox=graphbox.restrict_aspect(1.0).move_right(2.0).outset(0.4). move_down(0.1)
		tmpBox=draw_anim(animBox, int(5*animcu), showanimcu)
	
	if txt>epsilon:
		start=Vec2(canva[0]+canva.width()*0.4, canva[1]+canva.height()*0.75)
		c1=Color(coldic.font,clamp(txt))
		c2=Color(coldic.important,clamp(txt))
		text(start.x, start.y, [c1, "- Gnration et rendu ",c2," simultans"], timefont, size=fontSize, anchor="tw")
		start.y-=fontSize*1.1
		text(start.x, start.y, [c1, "- Rendu de l'avant vers l'arrire"], timefont, size=fontSize, anchor="tw")
		
		color(coldic.font,clamp(txt-2))
		start.y-=fontSize*1.1
		text(start.x, start.y, "- change GPU/CPU dans les 2 sens", timefont, size=fontSize, anchor="tw")
	
	if gpu>epsilon:
		gpubox=canva.inset(0.45).move_left(1.5).move_down(0.8)
		res=draw_gpu_and_screen(gpubox,thicknessSize,gpu)
		color(coldic.comment,gpu)
		xline=graphbox[0]+graphbox.width()*0.85
		line(xline, graphbox[1]-graphbox.height()*0.1, xline, graphbox[1]+graphbox.height())
		htext=graphbox[1]-fontSize*0.3
		x1=xline-fontSize*3
		x2=xline+fontSize*3
		color(coldic.font,gpu)
		text(x1,htext,"Processeur\ncentral",timefont,size=fontSize, anchor='tc', justify=0.5)
		text(x2,htext,"Carte\ngraphique",timefont,size=fontSize, anchor='tc', justify=0.5)
		
		x1+=fontSize*2
		x2-=fontSize*2
		harrow=htext+2*fontSize
		w=thicknessSize*12
		if echa>epsilon:
			color(blue,clamp(echa)*0.5)
			draw_arrow(x1,harrow,x2,harrow, w, w*2)
			color(red,clamp(echa-1))
			tmp=Rect(x1,harrow-w, x2, harrow+w)
			draw_cross(tmp,thicknessSize*3)
		
		if echa2>epsilon:
			color(blue,clamp(echa2)*0.5)
			draw_arrow(x1+(x2-x1)*0.5,harrow,x2,harrow, w, w*2)
			draw_arrow(x2-(x2-x1)*0.5,harrow,x1,harrow, w, w*2)




def dgVisibilite(
		build=(SCALAR,0,1.0,0.0),
		ecran=(SCALAR,0,1.0,0.0),
		txt=(SCALAR,0,3.0,0.0),
		txt2=(SCALAR,0,3.0,0.0),
		occ=(SCALAR,0,1.0,0.0),
		bb=(SCALAR,0,1.0,0.0),
		liste=(SCALAR,0,1.0,0.0),
		bbtxt=(SCALAR,0,1.0,0.0),
		vistxt=(SCALAR,0,1.0,0.0),
		slide=(SCALAR,0,1.0,0.0),
		shortcut=(SCALAR,0,1.0,0.0),
		slide2=(SCALAR,0,1.0,0.0),
		showpix=(SCALAR,0,1.0,0.0),
		paquet1=(SCALAR,0,10.0,0.0),
		showpaquet1=(SCALAR,0,1.0,0.0),
		movepaquet1=(SCALAR,0,1.0,0.0),
		paquet2=(SCALAR,0,10.0,0.0),
		showpaquet2=(SCALAR,0,1.0,0.0),
		movepaquet2=(SCALAR,0,1.0,0.0),
		gpuchoice=(SCALAR,0,1.0,0.5),
		drawgpu=(SCALAR,0,1.0,0.0),
		arrow=(SCALAR,0,1.0,0.0),
		nbpix=(SCALAR,0,1.0,0.0),
		occslide=(SCALAR,0,1.0,0.0)
	):
	wa=window_aspect()
	slideCoef=0.78
	canva=get_cams("dg_modelisation")
	set_camera(get_cams("dg_modelisation"))
	thicknessSize=wfunc(canva)
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	
	title(canva,"Visibilit : principe",1)
	
	if txt>epsilon:
		start=Vec2(canva[0]+canva.width()*0.07, canva[1]+canva.height()*0.75)
		color(coldic.font,clamp(txt))
		text(start.x, start.y, "- Similaire  [Yoon03] (simplification)", timefont, size=fontSize, anchor="tw")
		
		start.y-=fontSize*1.3
		color(coldic.font,clamp(txt-1))
		text(start.x, start.y, "- Bote englobante visible => l'objet peut-tre visible", timefont, size=fontSize, anchor="tw")
		
		start.y-=fontSize*1.3
		color(coldic.font,clamp(txt-2))
		text(start.x, start.y, "- GL_ARB_occlusion_query : compteur de pixels", timefont, size=fontSize, anchor="tw")
	
	if txt2>epsilon:
		start=Vec2(canva[0]+canva.width()*0.2, canva[1]+canva.height()*0.7)
		color(coldic.font,clamp(txt2))
		text(start.x, start.y, "- l'ordre est important", timefont, size=fontSize, anchor="tw")
		
		start.y-=fontSize*1.3
		color(coldic.font,clamp(txt2-1))
		text(start.x, start.y, "- envoi de requte par paquet (flush manuel)", timefont, size=fontSize, anchor="tw")
		
		start.y-=fontSize*1.3
		color(coldic.font,clamp(txt2-2))
		text(start.x, start.y, "- liste de priorit, heuristique (auto-occultation)", timefont, size=fontSize, anchor="tw")
	
	
	if ecran>epsilon:
		color(black,clamp(ecran))
		screenBox1=canva.inset(0.3).restrict_aspect(1.0).move_down(0.6). move_left(0.5)
		screenBox2=screenBox1.inset(0.3).move_right(2)
		screenBox3=screenBox2.inset(0.3).move_right(2)
		screenBox=screenBox1
		if slide>epsilon:
			screenBox=screenBox1.interp(screenBox2,slide)
		if slide2>epsilon:
			screenBox=screenBox2.interp(screenBox3,slide2)
		
		thickness(thicknessSize*0.5)
		Ecran(screenBox,10,1)
		
		if occ:
			r=screenBox.height()*0.4
			p1=Vec2(screenBox[0]+screenBox.width()*0.7, screenBox[1]+screenBox.height()*0.7)
			p2=Vec2(screenBox[0]+screenBox.width()*0.3, screenBox[1]+screenBox.height()*0.4)
			
			p=p1*(1-occslide)+p2*occslide
			tmpBox=Rect(p.x,p.y,width=r,height=r)
			box_image(tmpBox,ims["avion"],clamp(occ)*(1-bb))
			
			if bb>epsilon:
				box_image(tmpBox,ims["avionBB2"],clamp(occ)*pic(bb,1,0.3))
				box_image(tmpBox,ims["avionBB1"],clamp(occ)*pic(bb,2,0.3))
			
		box_image(screenBox,ims["occ"],clamp(ecran-1))
		color(orange,clamp(ecran))
		thickness(thicknessSize*2)
		frame(screenBox)
		
		p=Vec2(screenBox[0]+screenBox.width()*1.2, screenBox[1]+screenBox.height()*0.5)
		if showpix>epsilon:
			color(coldic.font,clamp(showpix))
			text(p.x,p.y, "nb pixel = "+str(int(nbpix)), timefont, size=fontSize, anchor="cw")

		if vistxt>epsilon:
			color(coldic.important,clamp(showpix))
			text(p.x, p.y-1.5*fontSize, "invisible", timefont, size=fontSize, anchor="cw")

		if bbtxt>epsilon:
			color(coldic.important,clamp(bbtxt))
			text(p.x, p.y+2.0*fontSize, "Botes englobantes", timefont, size=fontSize, anchor="cw")
			color(coldic.important,clamp(bbtxt-1))
			text(p.x, p.y+1.0*fontSize, "hirarchiques", timefont, size=fontSize, anchor="cw")
		
		if drawgpu>epsilon:
			color(coldic.font ,clamp(drawgpu))
			gpubox=scale_rect(screenBox.move_left(2),2,1)
			draw_gpu(gpubox,thicknessSize,drawgpu)
			
			if arrow>epsilon:
				c1=coldic.important.interp(coldic.comment,sqrt(gpuchoice))
				c2=coldic.important.interp(coldic.comment,sqrt(1-gpuchoice))
				m=Vec2(gpubox[0]+fontSize, gpubox[1]+gpubox.height()*0.5)
				dec1=Vec2(-5*fontSize,-2*fontSize)
				dec2=Vec2(dec1.x,-dec1.y)
				color(c1 ,clamp(arrow))
				Vec2.arrow(m+dec1,m+dec1*0.2,thicknessSize)
				p=m+dec1+Vec2(0,-fontSize*0.5)
				txt1="commande d'affichage"
				res1=text(p.x, p.y, txt1[int(shortcut*11):len(txt1)], timefont, size=fontSize, anchor="tc")
				color(c2 ,clamp(arrow))
				Vec2.arrow(m+dec2,m+dec2*0.2,thicknessSize)
				p=m+dec2+Vec2(0,fontSize*0.5)
				txt2="requte de visibilit"
				res2=text(p.x, p.y, txt2[int(shortcut*11):len(txt2)], timefont, size=fontSize, anchor="bc")
				
				color(black ,clamp(arrow))
				dot(fontSize*0.2,m.x,m.y)
				p=(m+dec1*0.2)*(1-gpuchoice)+(m+dec2*0.2)*(gpuchoice)
				Vec2.line(p,m)
			
			
			if showpaquet1>epsilon:
				color(black,showpaquet1)
				rbig=1.5*fontSize*(1-movepaquet1)
				rsmall=0.3*fontSize*(1-movepaquet1)
				p1=Vec2(res1["left"]-2*fontSize,res1["bottom"])
				p2=Vec2(gpubox[0]+fontSize, gpubox[1]+gpubox.height()*0.5)
				p=p1*(1-movepaquet1) + p2*(movepaquet1)
				circle(rbig,p.x,p.y)
				
				random.seed(295745)
				for i in range(0,int(paquet1)):
					color(random.random(),random.random(),1)
					dec=Vec2(random.random()-0.5,random.random()-0.5)*rbig*2*0.8
					c=1
					if i == int(paquet1)-1:
						c=paquet1-int(paquet1)
					dot(rsmall,p.x-(1-c)*3*fontSize+dec.x, p.y+dec.y)

			if showpaquet2>epsilon:
				color(black,showpaquet2)
				rbig=1.5*fontSize*(1-movepaquet2)
				rsmall=0.3*fontSize*(1-movepaquet2)
				p1=Vec2(res2["left"]-2*fontSize,res2["bottom"])
				p2=Vec2(gpubox[0]+fontSize, gpubox[1]+gpubox.height()*0.5)
				p=p1*(1-movepaquet2) + p2*(movepaquet2)
				circle(rbig,p.x,p.y)
				
				random.seed(295745)
				for i in range(0,int(paquet2)):
					color(random.random(),random.random(),1)
					dec=Vec2(random.random()-0.5,random.random()-0.5)*rbig*2*0.8
					c=1
					if i == int(paquet2)-1:
						c=paquet2-int(paquet2)
					dot(rsmall,p.x-(1-c)*3*fontSize+dec.x, p.y+dec.y)
			
			if liste>epsilon:
				rsmall=0.3*fontSize*(1-movepaquet2)
				parray=[Vec2(res1["left"]-6*fontSize,res1["bottom"]), Vec2(res1["left"]-6*fontSize,res2["bottom"])]
				random.seed(295745)
				for p in parray:
					r=fontSize
					c=0.2
					for i in range(0,3):
						color(random.random(),random.random(),1)
						dot(rsmall,p.x-(r*(1+c))*2*i,p.y)
						color(black,showpaquet2)
						circle(r,p.x-(r*(1+c))*2*i,p.y)
						line(p.x-(r*(1+c))*2*i-r,p.y, p.x-(r*(1+c))*2*i-r*(1+2*c), p.y)
					color(black,showpaquet2)
					draw_arrow(p.x+r, p.y, res2["left"]-3.5*fontSize-thicknessSize*3, p.y, thicknessSize)
