import random
from math import *
import sys

from slithy.library import *

from common import *
from ressource import *


#first page: presentation
def FirstPage(
		presentation=(SCALAR,0,1.0,1.0),
		motivation=(SCALAR,0,1.0,0.0),
		application1=(SCALAR,0,1.0,0.0),
		application2=(SCALAR,0,1.0,0.0),
		application=(SCALAR,0,1.0,0.0)
	):
	canva= get_cams("start")
	fontSize=canva.height()*textSize
	set_camera(canva)
	color(coldic.font,1)
	thicknessSize=canva.height()*0.005
	
	box=titleBox(canva).move_down(0.3)
	middle=get_middle(box)
	text(middle.x,middle.y,"Modlisation procdurale multi-chelle\nde scnes animes", timefont, size=canva.height()*titleSize, justify=0.5)
	
	color(coldic.font,presentation)
	
	box=box.move_down(1.5)
	middle=get_middle(box)
	text(middle.x,middle.y,"Frank Perbet\n\n\nEncadr par Marie-Paule Cani\net Przemyslaw Prusinkiewicz", timefont, size=fontSize, justify=0.5, anchor='cc')
	
	box=box.move_down(1.6)
	middle=get_middle(box)
	text(middle.x,middle.y,"Laboratoire GRAVIR,  Equipe EVASION", timefont, size=fontSize, justify=0.5)
	
	
	thickness(thicknessSize)
	color(coldic.font,motivation)
	
	boxImage=canva.top(0.5).restrict_aspect(ims["multi_scene"].aspect)
	boxImage=boxImage.inset(0.15).move_down(0.6)
	box_image(boxImage,ims["multi_scene"],motivation)
	
	motivation_txt="""
Motivations
	- Univers virtuels complexes
	- Grandes variations d'chelle
	- Rendu temps-rel
	- Animation
"""
	application_txt="""
Applications
	- Jeux vido
	- Logiciels pdagogiques
"""

	color(coldic.font,clamp(motivation-1))
	multi_text(canva[0]+canva.width()*0.3, canva[1]+canva.height()*0.4, motivation_txt,timefont, fontSize, 'tw')
	color(coldic.font,application)
	multi_text(canva[0]+canva.width()*0.1, canva[1]+canva.height()*0.6,application_txt,timefont, fontSize, 'tw')
	
	if application1>epsilon:
		ss=canva.width()*0.20
		tmpBox= Rect(canva[0]+canva.width()*0.8, canva[1]+canva.height()*0.4, width=ss,height=ss)
		for i in range(0,3):
			res=box_image(tmpBox.move_down((i-1)*0.85), ims["bw"+str(i+1)],application)
			color(coldic.font,application1)

	if application2>epsilon:
		tmpBox=canva.right(0.5).inset(0.2).restrict_aspect(ims["adn"].aspect). move_down(0.15).move_right(0.2)
		res=box_image(tmpBox, ims["adn"],application2)






dddFont=blue
#first page: presentation
def DDD(
		initarrow=(SCALAR,0,1.0,0.0),
		arrow=(SCALAR,0,10.0,0.0),
		choice=(SCALAR,0,10.0,0.5),
	):	
	item=["Etat de l'art","Rsolution d'un cas particulier : prairie","DynamicGraph : un outil gnrique","Rsultats et conclusion"]

	canva= get_cams("start")
	partBox=scale_rect(canva,0.9,0.6).move_down(0.1).top(1.0/len(item))
	
	camArray=[]
	aspect=window_aspect()
	for i in range(0,len(item)):
		camArray.append(partBox.restrict_aspect(aspect).move_down(i).inset(0.1))
		camArray.append(canva)
	
	cami=int(choice*2)
	c=choice*2-int(choice*2)
	if cami+1>=len(camArray):
		set_camera(camArray[len(camArray)-1])
	elif cami<0:
		set_camera(camArray[0])
	else:
		cam=camArray[cami].interp(camArray[cami+1],c)
		set_camera(cam)
	
	fontSize=canva.height()*textSize
	thicknessSize=canva.height()*0.005
	color(dddFont,1)
	thickness(thicknessSize)
	
	txt="Plan"
	middle=get_middle(titleBox(canva))
	text(middle.x ,middle.y ,txt, timefont, size=canva.height()*titleSize, justify=0.5)
	
	for i in range(0,len(item)):
		b=partBox.move_down(i)
		p=get_middle(b)
		color(dddFont,1-pic(choice,i,0.3))
		text(p.x,p.y,item[i],timefont, size=fontSize*1.2 ,anchor='cc')
		color(black,1-pic(choice,i,0.3))
		frame(b)
	
	alphaArrow=1-abs(((choice-int(choice))-0.5)*2)
	color(red,initarrow*alphaArrow*0.3)
	rectangle(partBox.move_down(arrow))
	
	
