import random
from math import *
import sys

from slithy.library import *

from common import *
from ressource import *


def brin(initp,size,amplitude,w,n=4):
	segsize=size/n
	angle=0
	current=initp
	angledec=amplitude*2.0/n
	for i in range(0,n):
		angle=angledec*(i+1)
		new=current+Vec2(sin(angle),cos(angle))*segsize
		thickness(4+10*float(n-1-i)/n)
		Vec2.line(current,new)
		current=new

def texSquel(box,amplitude,n,w,alpha):
	segsize=box.height()/n
	angle=0
	initp1=Vec2(box[0],box[1])
	initp2=Vec2(box[0]+box.width(),box[1])
	angledec=amplitude*2.0/n
	current1=initp1
	current2=initp2
	thickness(w)
	color(black,alpha)
	Vec2.line(current1,current2)
	for i in range(0,n):
		angle=angledec*(i+1)
		new1=current1+Vec2(sin(angle),cos(angle))*segsize
		new2=current2+Vec2(sin(angle),cos(angle))*segsize
		thickness(w*2)
		color(red,alpha)
		Vec2.line(current1,new1)
		Vec2.line(current2,new2)
		thickness(w)
		color(black,alpha)
		Vec2.line(new1,new2)
		current1=new1
		current2=new2


def fdec(y,ydec):
	return Vec2(ydec*y,ydec*y)


def draw3DSlice(box,ydec,a,b,w,dline):
	p1=Vec2(box[0],box[1])
	p2=Vec2(box[0]+box.width(),box[1])
	
	thickness(1)
	dec1=fdec(a,ydec)
	dec2=fdec(b,ydec)
	thickness(w)
	m1=p1+dec1
	m2=p2+dec1
	m3=p2+dec2
	m4=p1+dec2
	if dline:
		line(m1.x,m1.y,m2.x,m2.y,m3.x,m3.y,m4.x,m4.y,m1.x,m1.y)
		
	else:
		polygon(m1.x,m1.y,m2.x,m2.y,m3.x,m3.y,m4.x,m4.y,m1.x,m1.y)

def tex(box,ydec,seed,n,w,trans,trans2,drawSlice,alpha):
	random.seed(seed)
	box=box.bottom(trans2)
	l=[]
	for i in range(0,n):
		x=box.width()*(random.random())
		y=(random.random()-0.5)*2
		amp=(random.random()-0.5)*0.4
		size=box.height()*(0.6+0.3*random.random())
		l.append([x,y,amp,size])
	
	color(coldic.grass,alpha)
	for i in l:
		dec=fdec(i[1]*trans,ydec)
		brin(Vec2(box[0]+i[0]+dec.x,box[1]+dec.y),i[3],i[2],w)
	
	if drawSlice:
		color(coldic.comment,alpha)
		draw3DSlice(box,ydec,-1,1,w,True)
		thickness(w)
		frame(box)

def square(box,ydec,seed,nbSlice,nbBlade,w,trans,trans2,drawSlice,alpha):
	random.seed(seed)
	
	if trans2>epsilon:
		for i in range(0,nbSlice):
			p=fdec((nbSlice-1-i)*2.0,ydec)
			tmpBox=box.move_up(p.x,1).move_right(p.y,1)
			newSeed=int(10000*random.random())
			tex(tmpBox,ydec,newSeed,nbBlade,w,trans,trans2,drawSlice,alpha)



def brin2(initp,size,amplitude,w,ex,ey,n):
	segsize=size/n
	current=initp
	angledec=amplitude*2.0/n
	for i in range(0,n):
		angle=angledec*(i+1)
		new=current+Vec2(sin(angle),cos(angle))*segsize
		thickness(4+10*float(n-1-i)/n)
		a=ex*current.x+ey*current.y
		b=ex*new.x+ey*new.y
		Vec2.line(a,b)
		current=new


def square2(box,ydec,seed,nbSlice,nbBlade,w,trans,drawSlice,alpha):
	random.seed(seed)
	p1=Vec2(box[0],box[1])
	p2=Vec2(box[0]+box.width(),box[1])
	
	h1=Vec2(0,box.height()*0.7*trans)
	h2=Vec2(0,box.height()*0.3*trans)
	
	thickness(1)
	color(coldic.comment,alpha)
	dec1=fdec(-1,ydec)
	dec2=fdec(-1+2*nbSlice,ydec)
	thickness(w)

	m1=p1+dec1+h2
	m2=p2+dec1+h2
	m3=p2+dec2+h1
	m4=p1+dec2+h1
	line(m1.x,m1.y,m2.x,m2.y,m3.x,m3.y,m4.x,m4.y,m1.x,m1.y)
	
	ex=m2-m1
	ey=m4-m1
	
	
	if trans>epsilon:
		color(coldic.grass,trans*alpha)
		for i in range(0,nbBlade):
			push()
			translate(m1.x,m1.y)
			p=Vec2(0.05+0.9*random.random(),random.random()*0.8)
			s=random.random()*0.3
			a=random.random()-0.5
			brin2(p,s,a,w,ex,ey,2)
			pop()


def drawlod(smallbox,thicknessSize,fontSize,precision,alpha,alpha2):
	anchor='cw'
	ydec=2
	
	xdist=0.3
	p1=Vec2(smallbox[0]-smallbox.width()*xdist, smallbox[1]+smallbox.height()*0.5)
	color(coldic.lod2,alpha)
	rectangle(smallbox)
	color(black,alpha)
	frame(smallbox)
	text(smallbox[0]+smallbox.width()*1.5, smallbox[1]+smallbox.height()*0.5, "2D",timefont,size=fontSize,anchor=anchor)

	
	smallbox=smallbox.move_down(ydec)
	color(coldic.lod2_5,alpha)
	rectangle(smallbox)
	color(black,alpha)
	frame(smallbox)
	text(smallbox[0]+smallbox.width()*1.5, smallbox[1]+smallbox.height()*0.5, "2.5D",timefont,size=fontSize,anchor=anchor)
	
	
	smallbox=smallbox.move_down(ydec)
	p2=Vec2(smallbox[0]-smallbox.width()*xdist, smallbox[1]+smallbox.height()*0.5)
	color(coldic.lod3,alpha)
	rectangle(smallbox)
	color(black,alpha)
	frame(smallbox)
	text(smallbox[0]+smallbox.width()*1.5, smallbox[1]+smallbox.height()*0.5, "3D",timefont,size=fontSize,anchor=anchor)
	
	color(black,alpha)
	v=p2-p1
	Vec2.arrow(p1-v*0.1,p1+v*1.1,thicknessSize)
	text(p1.x,p2.y-2*fontSize,"Prcision",timefont,size=fontSize,anchor='bc')
	if precision>=0:
		dec1=Vec2(-30*thicknessSize,0)
		dec2=Vec2(-10*thicknessSize,0)
		color(red,alpha2)
		Vec2.arrow(p1+dec1+v*precision*0.5, p1+dec2+v*precision*0.5, thicknessSize*2)




def drawCam(p,a,l,decan):
	d1=Vec2(cos(a-decan),sin(a-decan))
	d2=Vec2(cos(a+decan),sin(a+decan))
	Vec2.line(p,p+d1*l)
	Vec2.line(p,p+d2*l)
	
	a=p+d1*(l*0.1)
	b=p+d2*(l*0.1)
	polygon(p.x,p.y,a.x,a.y,b.x,b.y)

def terrain(box,n,p,a,coord,alpha):
	decan=0.4
	d1=Vec2(cos(a-decan),sin(a-decan))
	d2=Vec2(cos(a+decan),sin(a+decan))
	dd1=Vec2(sin(a-decan),-cos(a-decan))
	dd2=Vec2(-sin(a+decan),cos(a+decan))
	
	c=1.0/n;
	sqsize=c*box.height()
	smallBox=Rect(box[0],box[1],sqsize,0,1)
	
	co=[coldic.comment,
		coldic.lod2,
		coldic.lod2_5,
		coldic.lod3 ]
	
	precision=0
	thebox=smallBox
	for i in range(0,n):
		for j in range(0,n):
			tmpBox=smallBox.move_right(i).move_up(j)
			m=get_middle(tmpBox)
			lc=m-p
			
			cal1=lc.x*dd1.x+lc.y*dd1.y
			cal2=lc.x*dd2.x+lc.y*dd2.y
			coef=0
			pprecision=0
			if (cal1<sqsize*0.5) and (cal2<sqsize*0.5) :
				dist=lc.norm()
				indf=3*dist/box.width()
				ind=int(indf)
				
				if indf<=1:
					color(co[3],alpha)
					pprecision=2
				elif indf<=1.1:
					color(co[3].interp(co[2],(indf-1)*10),alpha)
					pprecision=2-(indf-1)*10
				elif indf<=2:
					color(co[2],alpha)
					pprecision=1
				elif indf<=2.1:
					color(co[2].interp(co[1],(indf-2)*10),alpha)
					pprecision=1-(indf-2)*10
				else:
					color(co[1],alpha)
					pprecision=0
			else:
				pprecision=-1
				color(co[0],alpha)
			
			rectangle(tmpBox)
			
			if [i,j]==coord:
				thebox=tmpBox
				precision=pprecision
	
	color(black,alpha)
	for i in range(1,n):
		line(box[0]+c*i*box.width(), box[1], box[0]+c*i*box.width(), box[1]+box.height())
		line(box[0], box[1]+c*i*box.height(), box[0]+box.width(), box[1]+c*i*box.height())
	
	frame(box)
	
	drawCam(p,a,box.width(),decan)
	return [thebox,precision]


def graph(box,f,xxx,alpha,w,txt1,txt2,fontSize):
	color(black,alpha)
	o=Vec2(box[0],box[1])
	a1=Vec2(box[0]-box.width()*0.1, box[1])
	a2=Vec2(box[0]+box.width()*1.1, box[1])
	b1=Vec2(box[0], box[1]-box.height()*0.1)
	b2=Vec2(box[0], box[1]+box.height()*1.1)
	Vec2.arrow(a1,a2,w)
	Vec2.arrow(b1,b2,w)
	
	text(box[0]+box.width()*0.8, box[1]-w*0.5, txt1, timefont, size=fontSize, anchor='tc')
	
	text(box[0], box[1]+w*3.5+box.height(), txt2, timefont, size=fontSize, anchor='bc')
	
	color(red,alpha)
	current=Vec2(0,f(0)*box.height())
	m=100
	coef=1.0/m
	for i in range(1,m):
		x=i*coef
		new=Vec2(x*box.width(),f(x)*box.height())
		Vec2.line(o+current,o+new)
		current=new
	
	if xxx>0:
		thickness(w*2)
		color(coldic.comment,alpha)
		ll1=Vec2(box[0]+box.width()*xxx,box[1])
		ll2=Vec2(box[0]+box.width()*xxx,box[1]+box.height())
		Vec2.line(ll1,ll2)

def recepteur(p,fs):
	text(p.x,p.y,"R",timefont,size=fs,anchor='cc')
	circle(fs*0.8,p.x,p.y)
	

def bourasque(x):
	res=-exp(1.0/(0.15+(x-0.1)*(x-0.1)) + 1.0/(0.15+(x-0.7)*(x-0.7)))*(1-x*0.3)*x*(x-1)/1500
	return res

def topTextPos(box,fs):
	return Vec2(box[0]+box.width()*0.5,box[1])

def drawPrim(p,a,s,x,alpha):
	box=Rect(p.x,p.y,s,a,0.4)
	color(black,alpha)
	frame(box.move_right(4*x))
	color(orange,alpha*0.5)
	rectangle(box.move_right(4*x))
	rad=a*3.14*2/360

	

def prairie(
		build=(SCALAR,0,1.0,0.0),
		ter=(SCALAR,0,1.0,0.0),
		title=(SCALAR,0,2.0,0.0),
		showTxtIntro=(SCALAR,0,1.0,0.0),
		showTxtConclu=(SCALAR,0,1.0,0.0),
		txtIntro=(SCALAR,0,1.0,0.0),
		txtConclu=(SCALAR,0,1.0,0.0),
		camPos=(SCALAR,0,1.0,0.0),
		camrot=(SCALAR,0,1.0,0.0),
		showSquare=(SCALAR,0,1.0,0.0),
		showGraph=(SCALAR,0,1.0,0.0),
		primitive=(SCALAR,0,1.0,0.0),
		primitive2=(SCALAR,0,1.0,0.0),
		move_prim=(SCALAR,0,1.0,0.0),
		showres=(SCALAR,0,1.0,0.0),
		showTex=(SCALAR,0,1.0,0.0),
		anim_3d=(SCALAR,0,1.0,0.0),
		mov1=(SCALAR,0,1.0,0.0),
		anim_2d=(SCALAR,0,1.0,0.0),
		anim_2_5d=(SCALAR,0,3.0,0.0),
		anim_2_5d2=(SCALAR,0,3.0,0.0),
		mov2=(SCALAR,0,1.0,0.0),
		lod=(SCALAR,0,2.0,0.0),
		showLodArrow=(SCALAR,0,1.0,0.0),
		showLod=(SCALAR,0,1.0,0.0)):
	
	canva= get_cams("start")
	thicknessSize=canva.height()*0.005
	thickness(thicknessSize)
	fontSize=canva.height()*textSize
	senseBox=canva.top(0.3).inset(0.2).move_down(1.2)
	set_camera(canva)
	
	middle=get_middle(titleBox(canva).move_up(0.2))
	color(black,build)
	titleTxt="Prairie : "
	ti=["Vue d'ensemble", "3 niveaux de dtail", "animation" , "Rsultats", "Vers un outil gnrique"]
	for i in range(0,len(ti)):
		coef=int(len(ti[i])*pic(title,i,0.3))
		titleTxt+=ti[i][0:coef]
	text(middle.x,middle.y,titleTxt, timefont, size=canva.height()*titleSize, justify=0.5)
	
	terBox= canva.restrict_aspect(1.0).inset(0.3).move_left(0.6).move_down(0.2)
	
	if showTxtConclu>epsilon:
		space=1.5
		p=Vec2(canva[0]+fontSize*4,canva[1]+canva.height()*0.7)
		color(black,showTxtConclu*clamp(txtConclu-0))
		text(p.x,p.y-0*space*fontSize,"- Reprsentation et animation plausible",timefont,size=fontSize,anchor='tw')
		color(black,showTxtConclu*clamp(txtConclu-1))
		text(p.x,p.y-1*space*fontSize,"- Transition peu perceptible (continue)",timefont,size=fontSize,anchor='tw')
		color(black,showTxtConclu*clamp(txtConclu-2))
		text(p.x,p.y-2*space*fontSize,"- Mais trop de temps pass sur ",timefont,size=fontSize,anchor='tw')
		text(p.x+3*fontSize,p.y-2*space*fontSize-fontSize,"- Structure de donne dynamique\n- Calcul de la prcision et de la visibilit\n- Dboggage, modification", timefont,size=fontSize,anchor='tw')
		color(purple,showTxtConclu*clamp(txtConclu-3))
		text(canva[0]+canva.width()*0.5, canva[1]+canva.height()*0.2 ,"Ncessit d'un outil gnrique",timefont,size=fontSize,anchor="cc")
	
	if showTxtIntro>epsilon:
		space=1.5
		imBox=canva.top(0.5).inset(0.1).move_down(0.35). restrict_aspect(ims["prairieExp.jpg"].aspect)
		box_image(imBox,ims["prairieExp.jpg"],showTxtIntro)
		p=Vec2(canva[0]+fontSize*2,canva[1]+canva.height()*0.35)
		color(black,showTxtIntro*clamp(txtIntro-0))
		text(p.x,p.y-0*space*fontSize,"- But : prairie anime sous le vent",timefont,size=fontSize,anchor='cw')
		color(black,showTxtIntro*clamp(txtIntro-1))
		text(p.x,p.y-1*space*fontSize,"- Problme : performances !",timefont,size=fontSize,anchor='cw')
		color(black,showTxtIntro*clamp(txtIntro-2))
		text(p.x,p.y-2*space*fontSize,"- Solution : modlisation par complexification",timefont,size=fontSize,anchor='cw')
	
	if ter>epsilon:
		color(black,ter)
		text(terBox[0],terBox[1]+terBox.height()+fontSize*0.1, "Terrain", timefont, size=fontSize, justify=0.5, anchor='bw')
		p=Vec2(terBox[0]-terBox.width()*0.5*(1-camPos), terBox[1]+terBox.height()*0.5)
		res=terrain(terBox,8,p,1-camrot,[2,4],ter)
		lod=res[1]
		
		if showLod>epsilon:
			color(white)
			frame(res[0])
	
	
	if showLod>epsilon:
		anchor='cw'
		ydec=2
		smallbox=Rect(canva[0]+canva.width()*0.7, canva[1]+canva.height()*0.6, canva.height()*0.06,0,1)
		
		color(coldic.comment,showLod*ter)
		rectangle(smallbox)
		color(black,showLod*ter)
		frame(smallbox)
		text(smallbox[0]+smallbox.width()*1.5, smallbox[1]+smallbox.height()*0.5, "Non-visible", timefont, size=fontSize, anchor=anchor)
		
		smallbox=smallbox.move_down(ydec)
		drawlod(smallbox,thicknessSize,fontSize,lod,showLod,showLodArrow)
		
		
	if showSquare>epsilon:
		box=terBox.bottom(0.5)
		nbSlice=3
		ydec = box.width()/nbSlice*0.2
		color(coldic.terrain)
		draw3DSlice(box,ydec,-1,-1+2*nbSlice,thicknessSize,False)
		square2(box,ydec,8768,nbSlice,400,thicknessSize,1-clamp(lod), False, showSquare)
		square(box,ydec,8768,nbSlice,40,thicknessSize, clamp(lod-1), clamp(lod), False, showSquare)
		
		if showTex:
			box2=box.move_up(1.8).move_right(0.3)
			tex(box2,0,23432,30,thicknessSize,1,1,False,showTex)
			color(red,showTex)
			frame(box)
			frame(box2)
			
	
	if anim_3d>epsilon:
		p=getRelPos(canva,0.2,0.5)
		color(coldic.grass,anim_3d)
		hbrin=thicknessSize*30
		brin(p,hbrin,bourasque(mov1),hbrin,4)
		txt="""Rcepteur :
  - Amplitude
  - Orientation
"""
		
		color(black,anim_3d)
		pp=Vec2(p.x+canva.width()*0.3, p.y+canva.width()*0.2)
		text(pp.x, pp.y,txt, timefont,size=fontSize)
		
		color(purple,anim_3d)
		thickness(thicknessSize)
		recepteur(pp-Vec2(5*fontSize,0),fontSize)
		recepteur(p,fontSize)
		text(p.x,p.y-fontSize,"3D",timefont,size=fontSize,anchor='tc')
	
	if showGraph>epsilon:
		xxx=-1
		if mov1>epsilon:
			xxx=mov1
		elif mov2>epsilon:
			xxx=mov2
		
		graphBox=canva.bottom(0.3).inset(0.2).move_up(0.2)
		graph(graphBox,bourasque,xxx,showGraph,thicknessSize,"temps", "amplitude", fontSize)
	
	if anim_2d>epsilon:
		color(purple,anim_2d)
		p2d=getRelPos(canva,0.87,0.5)
		thickness(thicknessSize)
		recepteur(p2d,fontSize)
		text(p2d.x+fontSize,p2d.y,"2D",timefont,size=fontSize,anchor='cw')
	
	if anim_2_5d>epsilon:
		box2=terBox.move_right(0.7).top(0.4).move_up(0.23)
		
		tex(box2,0,23432,30,thicknessSize,1,1,False, clamp(anim_2_5d)*(1-clamp(anim_2_5d2-1)))
		texSquel(box2,bourasque(mov2),3,thicknessSize, anim_2_5d*clamp(anim_2_5d2))
		color(purple,anim_2_5d*clamp(anim_2_5d2))
		initp1=Vec2(box2[0],box2[1])
		initp2=Vec2(box2[0]+box2.width(),box2[1])
		thickness(thicknessSize)
		recepteur(initp1,fontSize)
		recepteur(initp2,fontSize)
		text(0.5*initp1.x+0.5*initp2.x, initp1.y-fontSize*0.5,"2.5D", timefont, size=fontSize, anchor='tc')
	
	
	if primitive>epsilon:
		newTerBox= canva.bottom(0.5).inset(0.13).move_down(0.05). move_right(0.3).restrict_aspect(1.0)
		color(black,primitive)
		p=Vec2(newTerBox[0]-newTerBox.width()*0.5*(1-camPos), newTerBox[1]+newTerBox.height()*0.5)
		
		res=terrain(newTerBox,8,p,0,[2,4],primitive)
		p=Vec2(newTerBox[0],newTerBox[1]-newTerBox.height()*0.1)
		a=20
		s=newTerBox.width()*0.3
		drawPrim(p,a,s,move_prim,primitive2)
		
		color(black,primitive)
		text(canva[0]+canva.width()*0.1,canva[1]+canva.height()*0.3, "Primitive de vent :\n- Fonction d'animation\n- Masque d'influence ", timefont, size=fontSize, anchor="cw")
	
	color(black,showres)
	if showres>epsilon:
		xfig_prairie.set(canva.inset(0.15).move_down(0.15))
		for i in xfig_prairie.listBox:
			tmpBox=xfig_prairie.get(i)
			box_image(tmpBox,ims[i],showres)
			if i == "vue_rasante.jpg":
				p=topTextPos(tmpBox,fontSize)
			elif i == "teapot.jpg":
				p=topTextPos(tmpBox,fontSize)
				text(canva[0]+canva.width()*0.5,p.y,"Premire version [Perbet01]:",timefont,size=fontSize, anchor='bc')
			elif i == "snapshotRelief.png":
				p=topTextPos(tmpBox,fontSize)
				text(canva[0]+canva.width()*0.5,p.y,"Seconde version [Guerraz03]:",timefont,size=fontSize, anchor='bc')
